//->stylepal
// v1.08 as amended by Nick Kaijaks <nick@kaijaks.co.uk>
// and Roger Noble <rgn@ukgateway.net>

int stylepal_palette;
int stylepal_centre;
int stylepal_handle;
int stylepal_view;
int stylepal_currnum;
int stylepal_prevnum=0;
int stylepal_start=-1;
int stylepal_user;
int stylepal_file;
int stylepal_stylesshaded;
int stylepal_remstylesshaded;
int stylepal_remeffectsshaded;
int stylepal_menuhandle;
int stylepal_miny;

int stylepal_x0;
int stylepal_y1;



int sty_tag=('s'<<24)|('t'<<16)|('y'<<8);


// read choices

void stylepal_readchoices(void)
{
 if(tagexists(0,sty_tag,0))
 {
  stylepal_palette=tagread(0,sty_tag,0);
  stylepal_x0=tagread(0,sty_tag,1);
  stylepal_y1=tagread(0,sty_tag,2);
  if(stylepal_x0<=0 && stylepal_y1<=0) stylepal_centre=1;
 }
 else
 {
  stylepal_palette=0; // use 1=open on startup, 0=closed on startup
  stylepal_centre=1; // use 1=palette centred, 0=template file position
 }

}


// write choices

void stylepal_writechoices(void)
{
 if(stylepal_centre==0)
 {
  tagwrite(0,sty_tag,stylepal_palette,0);
  tagwrite(0,sty_tag,stylepal_x0,1);
  tagwrite(0,sty_tag,stylepal_y1,2);
 }
}


// write choices

void stylepal_quit(int user)
{
 stylepal_writechoices();
}






// if state == 1 shade icon, otherwise unshade

void stylepal_shadeicon(int icon,int state)
{
 set_icon_state(stylepal_handle,icon,(1<<22)*state,(1<<22));
}


// if state has changed, shade/unshade the 'Remove styles' option

void stylepal_shaderemstyles(int state)
{
 if(state!=stylepal_remstylesshaded)
 {
  stylepal_shadeicon(0,state);
  stylepal_shadeicon(1,state);
  stylepal_remstylesshaded=!stylepal_remstylesshaded;
 }
}


// if state has changed, shade/unshade the 'Remove effects' option

void stylepal_shaderemeffects(int state)
{
 if(state!=stylepal_remeffectsshaded)
 {
  stylepal_shadeicon(2,state);
  stylepal_shadeicon(3,state);
  stylepal_remeffectsshaded=!stylepal_remeffectsshaded;
 }
}


// if state has changed, shade/unshade all of the Styles

void stylepal_shadestyles(int state)
{
 int i;

 if(state!=stylepal_stylesshaded)
 {
  for(i=stylepal_start;i<stylepal_currnum*4+stylepal_start;++i)
  {
   stylepal_shadeicon(i, state);
  }
  stylepal_stylesshaded=!stylepal_stylesshaded;
 }
}




// add rows from stylepal_prevnum to n

void stylepal_addrows(int n)
{
 int i, j;

 int col0x0=geticon(stylepal_handle,14,0);
 int col0x1=geticon(stylepal_handle,14,2);
 int col1x0=geticon(stylepal_handle,10,0);
 int col1x1=geticon(stylepal_handle,10,2);
 int col2x0=geticon(stylepal_handle,11,0);
 int col2x1=geticon(stylepal_handle,11,2);
 int col3x0=geticon(stylepal_handle,15,0);
 int col3x1=geticon(stylepal_handle,15,2);
 int stepy=geticon(stylepal_handle,12,3)-geticon(stylepal_handle,10,3);
 int y1coord;
 int y0coord;

 y1coord=geticon(stylepal_handle,4,1);
 y1coord+=stylepal_prevnum*stepy;
 y0coord=y1coord-(geticon(stylepal_handle,10,3)-geticon(stylepal_handle,10,1));


 for(i=stylepal_prevnum;i<n;i++)
 {
  j=create_icon(stylepal_handle,col0x0,y0coord,col0x1,y1coord,0,"\\a\\K1","abx",100+i*4);
  if(stylepal_start<0) stylepal_start=j;
  create_icon(stylepal_handle,col1x0,y0coord,col1x1,y1coord,0,"\\s\\K1","abx",101+i*4);
  create_icon(stylepal_handle,col2x0,y0coord,col2x1,y1coord,0,"\\R\\s\\K1","abx",102+i*4);
  create_icon(stylepal_handle,col3x0,y0coord,col3x1,y1coord,0,"\\s\\K1","abx",103+i*4);

  y1coord+=stepy;
  y0coord+=stepy;
 }

 stylepal_miny=y1coord;
}


// delete rows from n to stylepal_prevnum

void stylepal_delrows(int n)
{
 int i;

 for(i=n*4+stylepal_start;i<stylepal_prevnum*4+stylepal_start;++i)
 {
  delete_icon(stylepal_handle,i);
 }
}




// update icon and return 1 if it has changed

int stylepal_updateicon(int icon,int slice,string s)
{
 string t;
 int    code;

 code=read_slice_icon(stylepal_handle,icon,slice,t);
 if(code && t!=s)
 {
  write_slice_icon(stylepal_handle,icon,slice,s);
  return(1);
 }
 return(0);
}



// set state of 's', 'w' and 'l' scope flags

void stylepal_setscopestate(int icon,int state)
{
 set_icon_state(stylepal_handle,icon*4+stylepal_start+3,(1<<5)*state,(1<<5));
}


// update the style palette if it has changed

// {
//  stylepal_shaderemstyles(1);
//  stylepal_shaderemeffects(1);
//  stylepal_shadestyles(1);
// }
// else



void stylepal_update(int file)
{
 int tempview, i, c, active;
 string name, list, t;


 if(stylepal_file==file && file && stylepal_handle)
 {
  tempview=currentview();
  setcurrentfile(stylepal_file);

  stylepal_currnum=0;
  while(getuserstyle(stylepal_currnum++,name,1));

  if(--stylepal_currnum!=stylepal_prevnum)
  {
   if(stylepal_currnum>stylepal_prevnum) stylepal_addrows(stylepal_currnum);
   else                                  stylepal_delrows(stylepal_currnum);


   extent_window(stylepal_handle,0,stylepal_miny,1386,0);
   display_window(stylepal_handle,0,stylepal_centre);
   stylepal_prevnum=stylepal_currnum;
  }

  if((active=activetype(TEXTFRAME))<2)
  {
   stylepal_shaderemstyles(1);
   stylepal_shaderemeffects(1);
   stylepal_shadestyles(1);
  }
  else
  {
   stylepal_shadestyles(0);

   i=0;
   while(getcurrentstyle(i++, name, 2))
   {
    list+="\n"+name+"\n";
   }
   stylepal_shaderemstyles(i==1);
   stylepal_shaderemeffects(!islocaleffect());
  }


  i=0;
  while(getuserstyle(i,name,0))
  {
   t=list/("\n"+name+"\n")>=0?"oplus":"";
   t=active && iscurrentstyle(i)?"otick" :t;

   stylepal_updateicon(i*4+stylepal_start,'a',t);

   stylepal_updateicon(i*4+stylepal_start + 1,'s',name);

   getuserstyle(i,t,1);
   stylepal_updateicon(i*4+stylepal_start+2,'s',name==t?"":t<<slen(name));

   if(stylepal_updateicon(i*4+stylepal_start+3,'s',mids("s wlt",getstylescope(i),1)))
   {
    stylepal_setscopestate(i,getstylescope(i)!=1);
   }

   ++i;
  }

  setcurrentview(tempview);
 }
}




// return index of style present in selection

int stylepal_stylepresent(string style)
{
 int    i=0;
 string t;

 while(getcurrentstyle(i++,t,2))
 {
  if(t==style) return(i-1);
 }
}




// deal with clicks in Style palette window

void stylepal_click(int handle, int icon, int bbits, int mx, int my)
{
 string s;
 int    tempview;
 string t;

 tempview=currentview();
 setcurrentview(stylepal_view);

 if(bbits==1 && icon>=100) openstylebox(getuserstyle((icon-stylepal_start)/4,s,2));
 if(bbits==4 && icon>=0)
 {
  if(icon==10) remove_styles(0,0);
  else
  if(icon==12) cleareffects(0);
  else
  if(icon>=100)
  {
   if((icon-stylepal_start) % 4==0)
   {
    if(read_slice_icon(stylepal_handle,icon,'a',t) && t=="oplus")
    {
     remstyle(stylepal_stylepresent(readicon(stylepal_handle,icon+1)));
    }
	else
	{
     addstyle((icon-stylepal_start)/4);
	}
   }
   else
   {
    addstyle((icon-stylepal_start)/4);
   }
  }
 }
 setcurrentview(tempview);
}




// set window size according to the total number of styles

void stylepal_open3(int h,int x0,int y0,int x1,int y1,int scx,int scy,int bh)
{

 if(!stylepal_centre)
 {
  x1+=(stylepal_x0-x0);
  y0+=(stylepal_y1-y1);
  x0=stylepal_x0;
  y1=stylepal_y1;
 }
 else
 {
  stylepal_x0=x0;
  stylepal_y1=y1;
 }

 y0=y1+stylepal_miny-4;
 open_window(h,x0,y0,x1,y1,scx,scy,bh);

 stylepal_centre=0;
}



void stylepal_open5(int h,int x0,int y0,int x1,int y1,int scx,int scy,int bh)
{
 stylepal_x0=x0;
 stylepal_y1=y1;
}



// update palette when text at caret changes style or Edit Style box closed

void stylepal_textupdate(int user,int file)
{
 if(stylepal_palette && (!user || file==stylepal_file)) stylepal_update(file);
}



void stylepal_closewindow(void)
{
 close_window(stylepal_handle);
 delete_window(stylepal_handle);
 stylepal_view=0;
 stylepal_file=0;
 stylepal_handle=0;
 stylepal_prevnum=0;
 stylepal_start=-1;
}



void stylepal_closepalette(void)
{
 stylepal_closewindow();
}


// handler for close icon

void stylepal_closepal(int handle)
{
 stylepal_closepalette();
 stylepal_palette=0;
}




void stylepal_openwindow(int view)
{
 if(view)
 {
  stylepal_handle=create_windowparent("stylepal_m",viewhandle(view));

  setwindowflags(stylepal_handle,8,8);
  addwindowhandler(0,stylepal_handle,"stylepal_click");
  addwindowhandler(2,stylepal_handle,"stylepal_closepal");
  addwindowhandler(3,stylepal_handle,"stylepal_open3");
  addwindowhandler(5,stylepal_handle,"stylepal_open5");

  stylepal_view=view;
  stylepal_file=filefromview(view);
 }
}




void stylepal_openpalette(void)
{
 stylepal_openwindow(activeview());
 stylepal_update(stylepal_file);
}




void stylepal_activeview(int user,int view,int gain)
{
 if(gain && stylepal_palette && view && view!=stylepal_view)
 {
  stylepal_openwindow(view);
  display_window(stylepal_handle,0,stylepal_centre);
  stylepal_update(stylepal_file);
 }

 if(!gain && stylepal_palette && view && view==stylepal_view && stylepal_handle)
 {
  stylepal_closewindow();
 }

}





// open/close style palette

int stylepal_entry(int entry, int subcode)
{
 stylepal_palette=!stylepal_palette;

 if(!stylepal_palette) stylepal_closepalette();
 else                  stylepal_openpalette();

 return(0);
}


// tick or un-tick 'Style palette' menu entry

int stylepal_flags(int entry, string &text)
{
 return(stylepal_palette);
}




int stylepal_menu(int open)
{
 return(stylepal_menuhandle);
}




// add 'Style palette' option to 'Applets' menu

void main(void)
{
 string help = "{STYLEPAL_01}";

 script_menu_initialise();
 script_menu_insert("stylepal_entry","stylepal_flags","","","{STYLEPAL_00}");

 stylepal_readchoices();

 addeventhandler(0x304,0,"stylepal_textupdate");
 addeventhandler(0x305,1,"stylepal_textupdate"); // Edit Style box closed
 addeventhandler(0x215,0,"stylepal_activeview");
 addeventhandler(0x004,0,"stylepal_quit");

 if(isdefmacro("stylepal")==-1)
 {
  translate(help);
  defmacro3(0,"stylepal","{stylepal_entry(0,0)}","stylepal",help,"Stylepal");
 }
}
