// Version 1.07
//
// !Indexer (c) David Breakwell
// For use with Ovation Pro




string idx_entries, idx_order, idx_offsets, idx_index;
string idx_version;                               // Version 
int    idx_menu_h;                                // Menu Handle
int    idx_no_ent, idx_no_marks, idx_loop;        // Counters
int    idx_window_r, idx_window_i;                // Window Handles
int    idx_window_p, idx_window_o;
int    idx_window_con;                            // Conversion Window
int    idx_review_f;                              // Active File
int    idx_tag = 0x49445800;                      // Tag ID
string idx_this_ver = "IDX1.07";                  // Release Number
string idx_chp_page;                              // Chapter Page separator
int    idx_bm_stat;                               // Bookmark Status
int    idx_ent_stat;                              // Entry Status
int    idx_glb_stat;                              // Global Status
int    idx_inc_chp;                               // Include Chapter
int    idx_pg_tab;                                // Type Tab
int    idx_cap_e;                                 // Auto Cap
int    idx_ignore_c;                              // Ignore case when sorting
int    idx_miss_s;                                // Missing Style
int    idx_split_e;                               // Auto Split?

int    idx_active_view;                           // active view
int    idx_review_open;                           // Review Window Open?
int    idx_style_convert_menu = -1;               // List of Styles in Document
int    idx_nodelete = 0;                          // Flag for using !!!!!!!bm functions
int    idx_prompt_del = 0;                        // Prompt for deletion with delete key


// Setup Default Entry Lengths - used throughout the code below...

int idx_olen=6;        // Offset Length
int idx_ilen=7;        // Bookmark Length (IDX_Index)
int idx_iolen=6;       // Length of Entry part of the Index Entry
                       // ie 001!    ilen = 4, iolen = 3
int idx_orlen=6;       // Order Length (depends on Max number of Text Entries)
int idx_use_big_rev=1; // Use bigger review window (0=False) 1.05
string idx_bm = "IDX"; // BookMark Pre_Marker
string idx_split_char = "/"; // Character String used as a split Character Internally
string idx_not_tab = "    ";

// Key Shortcuts

string idx_review_key = "CS_F4";
string idx_type_key = "CS_F5";
string idx_info_key = "";

// Styles

string idx_ls = "IDXLETTER";
string idx_ns = "IDXSTYLE";


// Options file


int idx_fstyle(string s)
{
  int handle =0, r =1, f =-1; 
  string gotname;

  for(handle=0;((r!=0)&&(f==-1)); handle++)
  {
    r=getuserstyle(handle,gotname,0);
    if(gotname==s) f = handle;
  }
  return f;
}

void idx_clears()
{               

  int l;
  string s;

  //seteffect(NORMAL); // Reset Styles
   cleareffects(0);
   for(l=0; getcurrentstyle(l,s,2)>0; l++)
    remstyle(l);
}

string idx_read_entry ( int ent )
{ 
  int o,p,t;
  o = stoi(mids(idx_offsets, ent*idx_olen, idx_olen));
  p = stoi(mids(idx_offsets, ( ent + 1 )*idx_olen, idx_olen)) - o;
  return ( mids(idx_entries, o, p) ); // Complete Entry
}

string idx_main_e ( string s )
{
  int o;
  o = s / idx_split_char;
  if(o>=0){
  return (mids(s,0,o));
  }
  else
  {return "";}
}

string idx_minor_e (string s)
{
  int o;
  string t;
  o =  s / idx_split_char;
  if(o>=0){
    t = (mids(s, o+1, slen(s) - o));
    o = t / idx_split_char;                      
    if(o>=0){
      return(mids(t, 0, o));
    }
    else
    {return t;}
  }
  else
  {return "";
  }
}    

string idx_opt_e (string s)
{
  int o;
  string t; 

  o= s / idx_split_char;
  if(o>=0)
  {
    t =  (mids(s, o+1, slen(s) - (o+1)));
    o = t / idx_split_char;
    if(o>=0)
    {
      return(mids(t,o+1, slen(t)-(o+1)));               
    } 
    else
    { 
      return " ";
    }
  }
  else
  {
    return " ";
  }
}  

void idx_up_gopt()
// Global Options
{
 if(idx_window_o)
 {
  select_icon(idx_window_o,0,idx_inc_chp);
  select_icon(idx_window_o,101,idx_pg_tab);
  select_icon(idx_window_o,102,idx_cap_e);
  select_icon(idx_window_o,3,idx_miss_s);
  select_icon(idx_window_o,12,idx_split_e); // Split Entries
  select_icon(idx_window_o,13,idx_prompt_del); // Delete Prompt
  select_icon(idx_window_o,14,idx_ignore_c); // Ignore Case when sorting
  writeicon(idx_window_o,7,idx_review_key);
  writeicon(idx_window_o,8,idx_type_key);
  writeicon(idx_window_o,9,idx_info_key);
 }
}



void idx_put_gopt()
{
 tagwrite(0,idx_tag,4,0);          //Version
 tagwrite(0,idx_tag,idx_inc_chp,1);
 tagwrite(0,idx_tag,idx_pg_tab,2);
 tagwrite(0,idx_tag,idx_cap_e,3);     // New in this release
 tagwrite(0,idx_tag,idx_miss_s,4);
 tagwrite(0,idx_tag,idx_ignore_c,5);
 tagwrite(0,idx_tag,idx_split_e,6);
 tagwrite(0,idx_tag,idx_prompt_del,7);

 tagwrites(0,idx_tag+1,idx_review_key);
 tagwrites(0,idx_tag+2,idx_type_key);
 tagwrites(0,idx_tag+3,idx_info_key);
}



void idx_save_gopt()
{
 idx_review_key=readicon(idx_window_o,7);
 idx_type_key=readicon(idx_window_o,8);
 idx_info_key=readicon(idx_window_o,9);
 idx_put_gopt();
}



void idx_set_gopt(void)	 // Set Global Options
{ 
  int v;

  idx_inc_chp = 0;
  idx_pg_tab  = 1;
  idx_cap_e   = 0;
  idx_miss_s  = 0;
  idx_split_e = 0;
  idx_prompt_del = 0;            
  idx_ignore_c = 0;

  if(!tagexists(0,idx_tag,0))
  {
   idx_put_gopt(); //Save Options 
  }                
  else
  {               
   v=tagread(0,idx_tag,0); // file version
   idx_inc_chp=tagread(0,idx_tag,1);
   idx_pg_tab=tagread(0,idx_tag,2);
   idx_cap_e=tagread(0,idx_tag,3);
   idx_miss_s=tagread(0,idx_tag,4);
   idx_ignore_c=tagread(0,idx_tag,5);
   idx_split_e=tagread(0,idx_tag,6);
   idx_prompt_del=tagread(0,idx_tag,7);
    

   tagreads(0,idx_tag+1,idx_review_key);
   tagreads(0,idx_tag+2,idx_type_key);
   tagreads(0,idx_tag+3,idx_info_key);
  }


}                   

string idx_set_cap(string s)
{
  int loop,ic;           
  string last,total;
  

   
  loop = 0; ic = 0;       
  total=""; last =" ";
  while(loop!=slen(s))
  { if(ic==0)
    {
      if(last==" ")
      {
        total = total + (+mids(s,loop,1));
      }
      else
      {
        total = total + (-mids(s,loop,1));
      }
    }
    else
    {
      total = total + mids(s,loop,1);
    }
    last = mids(s,loop,1);
    if(last=="{")
    {
      ic = 1;
    }
    if(last=="}")
    {
      ic = 0;
    }
    loop = loop + 1;
  }
  return total;
} 

string idx_auto_cap(string s)
{
   string t;  

   if(idx_cap_e==1)
   {
     return idx_set_cap(s);
   }
   else
   {
     return s;
   }
}

int idx_read_order ( int i)
// Read Entry in Alpha order
{
  return (stoi(mids(idx_order, i*idx_orlen, idx_orlen))-1);
}                         

string idx_digit_three(int i)
{     
   string n;
   n="000000"+itos(i);
   n=mids(n,slen(n)-idx_olen,idx_olen);
   return n;
}   
                     
string idx_digit_three_old(int i)
// Return a number as a string length 5
{
  string n;
  n = itos(i);
  n = "0"*(5-slen(n))+n;
  if(i>99999)
  {
    messagebox("Error in Number Conversion");
  }  
  return n;
}

int idx_add_entry( string s)
{          
   int r,loop;               
   string c;

  if(idx_no_ent<=0)
  {
    idx_offsets=idx_digit_three(0);
    idx_no_ent = 0;
  }                  
  r = -1; loop = 0;
  while((loop<idx_no_ent)&&(r==-1))
  {
    c = idx_read_entry(loop);
    if(c==s)
    {
      r = loop;
    }        
    loop = loop + 1;
  }
  if(r==-1)
  // No existing entry...
  {
  idx_entries = mids(idx_entries,0,stoi(mids(idx_offsets,(idx_no_ent)*idx_olen,idx_olen)));
  idx_entries = idx_entries + s;
  idx_order = mids(idx_order, 0, idx_no_ent*idx_orlen) + idx_digit_three(idx_no_ent+1);
  idx_offsets = mids(idx_offsets, 0, (idx_no_ent+1)*idx_olen) + 
                idx_digit_three(stoi(mids(idx_offsets,(idx_no_ent)*idx_olen ,idx_olen))+slen(s));
  idx_no_ent = idx_no_ent + 1;
  r = idx_no_ent - 1;
  }
  return r;

}           

string idx_strip_ctl(string s, int do_i_ignore)
{           
   string t;
   int    f,l;
   
   l=0; f = 0;
   while(l!=slen(s))
   {
     if(mids(s,l,1)=="{")
     {
       f = 1;
     }
     if(f==0)
     {              
       if(do_i_ignore==1)
       {    
       t =t + (+mids(s,l,1));
       }
       else
       {  if(idx_ignore_c==0)
          {
            t = t + mids(s,l,1);
          }
          else
          {
            t =t + (+mids(s,l,1));
          }
        }
     }
     if(mids(s,l,1)=="}")
     {
       f = 0;
     }
     l = l + 1;
   }           

   return t;
}

void idx_bm_swp(int bm1, int bm2)
// bm, bm2 are the numbers of  IDX001, IDX002 for example
{
  int bms;     
  
 bms= bmcreate(idx_bm+"SWP");
 setbmtobm(bms,bmfind(idx_bm+idx_digit_three(bm1)));
 setbmtobm(bmfind(idx_bm+idx_digit_three(bm1)),bmfind(idx_bm+idx_digit_three(bm2)));
 setbmtobm(bmfind(idx_bm+idx_digit_three(bm2)),bms);
 bmdelete(bms);
}

void idx_bm_sort()

// Sort Bookmarks for the same text entry
{
  int loop, iloop;
  int ent, ient, swap, c, p;

  loop = 0;
  while(loop< idx_no_marks)
  {
    ent = stoi(mids(idx_index,loop*idx_ilen,idx_iolen));
    iloop = loop + 1;
    while(iloop<idx_no_marks)
    {
      ient = stoi(mids(idx_index,iloop*idx_ilen,idx_iolen));

      if(ient==ent)
      {
        if(bmchapter(bmfind(idx_bm+idx_digit_three(loop)))>
              bmchapter(bmfind(idx_bm+idx_digit_three(iloop))))
        {
          idx_bm_swp(loop,iloop);
        }
        if(bmchapter(bmfind(idx_bm+idx_digit_three(loop)))==
              bmchapter(bmfind(idx_bm+idx_digit_three(iloop))))
        {
          if(bmpage(bmfind(idx_bm+idx_digit_three(loop)))>
              bmpage(bmfind(idx_bm+idx_digit_three(iloop))))
          idx_bm_swp(loop,iloop);
        }
      }
      iloop = iloop + 1;
    }
    loop = loop + 1;
  }
  
}
          

    
void idx_qsort(int left, int right)
{
  int i,j,k,exit;
  string x,y,x_m,x_s,y_m,y_s,swap;
  i=left; j=right; k = (left+right) / 2;
  x= idx_read_entry( idx_read_order(k));
  x_m = idx_strip_ctl(idx_main_e(x),1);
  x_s = idx_strip_ctl(idx_minor_e(x),1);
//  messagebox("Xm "+x_m);
//  messagebox("Xs "+x_s);
  
  do 
  {             
    exit =0;
    while ( (i<right) &&  
        ( (idx_strip_ctl(idx_main_e(idx_read_entry(idx_read_order(i))),1)) <= x_m )
        && (exit==0))
    {                                                                        
      if ( (idx_strip_ctl(idx_main_e(idx_read_entry(idx_read_order(i))),1)) < x_m )
      {
     i=i+1;
      }     
      else
      {
        if ( (idx_strip_ctl(idx_minor_e(idx_read_entry(idx_read_order(i))),1)) < x_s )
        {
          i = i + 1;
        } else
        { exit = 1; };
      };
    };          
    exit = 0;
    while ( (j>left) &&  
        ( x_m <= (idx_strip_ctl(idx_main_e(idx_read_entry(idx_read_order(j))),1)))
        && (exit==0))
    {                                                                        
      if ( x_m < (idx_strip_ctl(idx_main_e(idx_read_entry(idx_read_order(j))),1))  )
      {
     j=j-1;
      }     
      else
      {
        if ( x_s< (idx_strip_ctl(idx_minor_e(idx_read_entry(idx_read_order(j))),1)))
        {
          j = j - 1;
        } else
        { exit = 1; };
      };
    };          
//    while ( (j>left) &&
//      ( x_m < (idx_strip_ctl(idx_main_e(idx_read_entry(idx_read_order(j))),1)) ))
//       && ( x_s < (idx_strip_ctl(idx_minor_e(idx_read_entry(idx_read_order(j))),1)))) 
//    { j=j-1; };
//    while ( (j>left) &&
//      ( x_m == (idx_strip_ctl(idx_main_e(idx_read_entry(idx_read_order(j))),1)) )
//       && ( x_s < (idx_strip_ctl(idx_minor_e(idx_read_entry(idx_read_order(j))),1)))) 
//    { j=j-1; };

    if(i<=j){
      if(i<j){
  //    messagebox("Swap "+itos(i)+" "+itos(j));
      swap = mids(idx_order, j*idx_orlen ,idx_orlen);

        idx_order = mids(idx_order, 0, i*idx_orlen) 
             + swap 
             + mids(idx_order, (i+1)*idx_orlen, (j*idx_orlen)-(i+1)*idx_orlen)
             + mids(idx_order, i*idx_orlen, idx_orlen) 
             + mids(idx_order,(j+1)*idx_orlen , idx_no_ent*idx_orlen-((j+1)*idx_orlen));
      };
             i=i+1; j=j-1;
    };
  } while(i<=j);
  if(left<j)  idx_qsort(left,j);
  if(i<right)  idx_qsort(i,right);

}

void idx_sort()
{     
                
  messagebox("Sorting Index - Press Continue to Start - This Process can take a while.");
//  swi13(0x406c0,0,0,0); 
  idx_qsort(0,idx_no_ent-1);
//  swi13(0x406c01,0,0,0);
  messagebox("Index Sorted - Press Continue");
}

void idx_sort2()
// Sorts the Text Entries for the Index
// No Longer Used see sort above

{
  int    loop, iloop;
  string test, test2, swap;

  loop = 0;
  while(loop < idx_no_ent){
    test = idx_read_entry( idx_read_order(loop));
    iloop = loop + 1;
    while(iloop < idx_no_ent){
      test2 = idx_read_entry(idx_read_order(iloop));
      if(idx_strip_ctl(idx_main_e(test),1) > idx_strip_ctl(idx_main_e(test2),1)){
        swap = mids(idx_order, iloop*idx_orlen ,idx_orlen);
        idx_order = mids(idx_order, 0, loop*idx_orlen) 
             + swap 
             + mids(idx_order, (loop+1)*idx_orlen, (iloop*idx_orlen)-(loop+1)*idx_orlen)
             + mids(idx_order, loop*idx_orlen, idx_orlen) 
             + mids(idx_order,(iloop+1)*idx_orlen , idx_no_ent*idx_orlen-((iloop+1)*idx_orlen));
        swap = test;
        test = test2;
        test2 = swap;
      }; 

      if(idx_strip_ctl(idx_main_e(test),1) == idx_strip_ctl(idx_main_e(test2),1)){
        if( idx_strip_ctl(idx_minor_e(test),1) > idx_strip_ctl(idx_minor_e(test2),1)){
          swap = mids(idx_order, iloop*idx_orlen ,idx_orlen);
          idx_order = mids(idx_order, 0, loop*idx_orlen) + 
              swap +
              mids(idx_order, (loop+1)*idx_orlen, (iloop*idx_orlen)-(loop+1)*idx_orlen) +
              mids(idx_order, loop*idx_orlen, idx_orlen) +
              mids(idx_order,(iloop+1)*idx_orlen , idx_no_ent*idx_orlen-((iloop+1)*idx_orlen));
          swap = test;
          test = test2;
          test2 = swap;     
        }
      }
      iloop = iloop + 1;
    }                   
   loop = loop + 1;
  }
}

void idx_opt_on(string s)

{
  string t1;
  int o;    
  cleareffects(0);
  t1 = idx_opt_e(s);
  o = t1 / "S";
  if(o>=0){
    t1 = mids(t1,0,t1/"S");
  }             
  o = t1 / "B";
  if(o>=0){
    seteffect(2);
  }
  o = t1 / "I";
  if(o>=0){           
    seteffect(4);
  }
  o = t1 / "A";
  if(o>=0){           
    seteffect(4);
    seteffect(2);
  }  
 // messagebox(idx_ns+t1);
  o = "0123456789" / t1;
 // messagebox(itos(o));
  if(o>=0){
    idx_clears();
    if(idx_fstyle(idx_ns+t1)!=-1)
    {
     addstyle(idx_fstyle(idx_ns+t1)); 
    }
  }
}

void idx_optbm_on(string s)

{                 
  int c;        
  cleareffects(0);
  c=schar(s,0);    
  if((c&1)!=0){
   seteffect(2);
  }
  if((c&8)!=0){     
    seteffect(4);
  }
}

void idx_optbm_off(string s)
// Bits 1 and * used to control styles
{                   
  int c;
  c=schar(s,0);    
  if((c&1)!=0){
    seteffect(2);
  }
  if((c&8)!=0){
    seteffect(4);
  }
}
                 

void idx_opt_off(string s)

{
  string t1;
  int o;            
  cleareffects(0);  
  idx_clears();
  t1 = idx_opt_e(s);
  o = t1 / "S";
  if(o>=0){
    t1 = mids(t1,0,t1/"S");
  }
  o = t1 / "B";
  if(o>=0){
    seteffect(2);
  }
  o = t1 / "I";
  if(o>=0){
    seteffect(4);
  }
  o = t1 / "A";
  if(o>=0){
    seteffect(4);
    seteffect(2);
  }                        
  o = "0123456789" / t1;
  if(o>=0){
    idx_clears();
  }
}

void idx_type_page(int c, int o)
{
// Type a page number in chapter c's number format
if(programversion()>=257)
    {
      switch((chapterbits(c,currentfile())&0xF0)>>4)
      {
        case 0 : type(itors(o)); break;   
        case 1 : type(-itors(o)); break;     
        case 2 : type(itos(o)); break;
      }                         
    }
    else
    {
      type(itos(o));
    }
}

void idx_ins_pg( int bm, string s, string name, int ic, string bms)
{
// Either insert See Entry... or the Page Number
// ic == include chapter number in page reference

  string t;
  int o;
  
  t = idx_opt_e(s);
  o = t / "S";
  if(o>=0){              
  // See Entry
    o = t / idx_split_char;         
    t = mids(t,o+1, slen(t)-(o+1));
   idx_optbm_on(bms);
   type(t);
   idx_optbm_off(bms);
  }
  else
  {
    idx_optbm_on(bms);
    o = pagestart(bmchapter(bm),currentfile());
    o = o + bmpage(bm);
    if(ic != 0){
      type(itos(bmchapter(bm)+chapterstart(currentfile())));
      type(idx_chp_page);
    }
    idx_type_page(bmchapter(bm),o);
    
   //   type(itos(o));
   
    idx_optbm_off(bms);
    if((bmfind(name+"A"))!=0){
    // Check for a Range and include it if present
      type("-");
      idx_type_page(bmchapter(bm),
                    pagestart(bmchapter(bm),currentfile())+bmpage(bmfind(name+"A")));
//      type(itos(pagestart(bmchapter(bm),currentfile())+bmpage(bmfind(name+"A"))));
    }
    
  }
}              

void idx_cp_sep()
{
  // Does not appear to work :. hard code .
  int a, i, p, u, c , s;
//  generalpref(a,i,p,u,c,s);
  idx_chp_page = chars(s);
  idx_chp_page=".";
}

void idx_type_index()
{
  int loop, iloop, print, bm; 
  string s;        
  int ppage,pchap; 
  int pc;             //1.07

  idx_cp_sep();
  // Type Index        
//  swi13(0x406c0,0,0,0);
  type(" {CLeft}"); // Fix the first BM at the Start of the INDEX
  bm=bmcreate(idx_bm+"STR");
  setbmtocaret(bm);
  type("{CRight}");
  idx_clears(); // Clear all Styles
  loop = 0;             
  // Outer Loop - Index Entries (texts)
  while(loop != idx_no_ent){           
    pc=(loop*100/idx_no_ent);
  //  messagebox(itos(pc));
//    swi13(0x406c4,pc,0,0);
    iloop = 0;    
    print = 0;   // Have I printed this entry yet
    ppage=-1; // Previously printed Page and Chapter
    pchap=-1;                  
    s = idx_read_entry( idx_read_order(loop));
    // Inner Loop - Bookmarks 
    while(iloop !=idx_no_marks){   // Find Marks for Index Entry Number
      // Bookmark for this Index? 
//      pc=((loop/idx_no_ent)*100);
//      swi13(0x406c4,pc,0,0);
      if(stoi(mids(idx_index,iloop*idx_ilen,idx_iolen)) == idx_read_order(loop)){
        // Printed this text entry Before?
        if(print!=1){
          print = -1;
          if(idx_strip_ctl(idx_main_e(idx_read_entry( idx_read_order(loop))),0) == 
                   idx_strip_ctl(idx_main_e(idx_read_entry( idx_read_order(loop-1))),0)&(loop!=0))
          // Minor Entry difference from last text Entry

          {  type("{Return}"); // Indent for Sub Entry
             idx_opt_on(s);
              if(programversion()>=257)
               {
             //  idx_clears();
               addstyle(idx_fstyle(idx_bm+"SUB"));
               }
               else
               {
               addstyle(idx_fstyle(idx_bm+"RSL"));
               };
             //addstyle(idx_fstyle(idx_bm+"RSL"));
             type("{tab}");
             type(idx_minor_e(idx_read_entry( idx_read_order(loop))));
             idx_opt_off(s);
             if(programversion()<257)
               {
             addstyle(idx_fstyle(idx_bm+"RSR"));
             };
             if(idx_pg_tab!=0)
             {
             type("{Tab}");
             }
             else
             {
             type(idx_not_tab); // Some spaces
             }
          }
          else        
          {                                                         

          // New Main Index Item
          // Check for Change of Letter and Print New Alphabet Header

            if(((mids(idx_strip_ctl(idx_main_e(idx_read_entry( idx_read_order(loop))),0),0,1))
             != (mids(idx_strip_ctl(idx_main_e(idx_read_entry( idx_read_order(loop-1))),0),0,1)))
                 ||(loop==0))
            {
              type("{Return}{Return}"); 
              idx_clears();
              if(idx_fstyle(idx_ls)!=-1)
              {

              addstyle(idx_fstyle(idx_ls)); 
              }
              
              type(mids(idx_main_e(idx_strip_ctl(idx_read_entry( idx_read_order(loop)),0)),0,1)); 

              if(idx_fstyle(idx_ls)!=-1)
              {
               idx_clears(); 
              }
            type("{Return}");   
            } // New Header Letter

            type("{Return}");        
            idx_opt_on(s);
            addstyle(idx_fstyle(idx_bm+"RMN"));
            type(idx_main_e(idx_read_entry( idx_read_order(loop))));
            idx_opt_off(s);
            addstyle(idx_fstyle(idx_bm+"RMN"));
            if(idx_minor_e(idx_read_entry( idx_read_order(loop)))!="")
            // Check for Minor entry
            {  type("{Return}");
               idx_opt_on(s);            
        //       messagebox(itos(programversion()));
               if(programversion()>=257)
               {
//               idx_clears();
               addstyle(idx_fstyle(idx_bm+"SUB"));
               }
               else
               {
               addstyle(idx_fstyle(idx_bm+"RSL"));
               };
               type("{tab}");
               type(idx_minor_e(idx_read_entry( idx_read_order(loop))));
               idx_opt_off(s);
               if(programversion()<257)
               {
               addstyle(idx_fstyle(idx_bm+"RSR"));
               };
               if(idx_pg_tab!=0)
               {
               type("{Tab}");
               }       
               else
               {
               type(idx_not_tab);
               }
               
            } 
            else
            {   // No Minor Entry
              
              //type("{Tab}");
              if(idx_pg_tab!=0)
              {
              
                type("{Tab}");     // No Minor Entry
                if(idx_fstyle(idx_bm+"RMN")==-1)
                {
                type("{Tab}");
                }
              }          
              else
              {
              type(idx_not_tab);
              }
            }      // No minor
          } // Minor or Major entry
        }  // Printed before
        else
        {
      //    type(","); // additional Bookmark for same Index 
        };
        bm = bmfind(idx_bm+idx_digit_three(iloop));
        if((bmchapter(bm)==pchap)&(bmpage(bm)==ppage))
        {                             
          // Same page and chapter as the last one printed!
        }
        else
        { 
          if(print==1)
          {
            type(",");
          }
          print = 1;
          pchap = bmchapter(bm);
          ppage=bmpage(bm);
          idx_ins_pg(bm, idx_read_entry( idx_read_order(loop)), 
                     idx_bm+idx_digit_three(iloop),idx_inc_chp,
                     mids(idx_index,(iloop*idx_ilen)+idx_iolen,idx_ilen-idx_iolen));
          idx_opt_off(s);
        }
      } // Bookmark for this Index
      iloop += 1; // Bookmarks
    }            
    loop += 1; // Index Entries
  }                      
  bm=bmcreate(idx_bm+"END");
  setbmtocaret(bm);
  bm=bmfind(idx_bm+"STR");
  setcarettobm(bm);
  type("{Copy}{Copy}{Copy}"); // Delete the Temporary Space
//  swi13(0x406c1,0,0,0);
}              



void idx_locate_cursor()
{
  int bm,bm2,reply;
 
  bm  = bmfind(idx_bm+"STR");
  bm2 = bmfind(idx_bm+"END");
  
  if((bm!=0)&&(bm2!=0)){
    reply = confirmparent("Replace Existing Index?",viewhandle(currentview()));
    if(reply == 1){
      setcarettobm(bm2);
      setzonetobm(bm);
      type("{Delete}");
      setcarettobm(bm);
    
     };                      
   };
   if(bm!=0){
     bmdelete(bm);
   };
   if(bm2!=0){
     bmdelete(bm2);
   };
   idx_clears();

}



void idx_del_entry(int n)
// Delete Index Entry (text) - used by index_delete
{
  int o,s,loop;         

  o = stoi(mids(idx_offsets,n*idx_olen,idx_olen));
  s = stoi(mids(idx_offsets,(n+1)*idx_olen,idx_olen));

  idx_entries = mids(idx_entries,0,o)
                +mids(idx_entries,s,stoi(mids(idx_offsets,idx_no_ent*idx_olen,idx_olen)));   
  idx_offsets = mids(idx_offsets,0,n*idx_olen)
                +mids(idx_offsets,(n+1)*idx_olen,((idx_no_ent+1)-(n+1))*idx_olen);
  loop = n;
  while(loop!=idx_no_ent)
  {                     
    idx_offsets = mids(idx_offsets,0,loop*idx_olen) 
      + idx_digit_three(stoi(mids(idx_offsets,loop*idx_olen,idx_olen))-(s-o)) 
      + mids(idx_offsets,(loop+1)*idx_olen,slen(idx_offsets)-(loop+1)*idx_olen);
    loop = loop + 1;
  }                        
  // Reduce references to texts by 1 for entries > deleted entry
  loop = 0;
  while(loop!=(idx_no_marks))
  {
    if(stoi(mids(idx_index,loop*idx_ilen,idx_iolen))>n)
    {
      idx_index = mids(idx_index,0,loop*idx_ilen)
                +idx_digit_three(stoi(mids(idx_index,loop*idx_ilen,idx_iolen))-1)+
                mids(idx_index,loop*idx_ilen+idx_iolen,idx_ilen-idx_iolen)+
              mids(idx_index,(loop+1)*idx_ilen,(idx_no_marks)*idx_ilen-(loop+1)*idx_ilen);
    }
    loop = loop + 1;
  }
  idx_no_ent = idx_no_ent - 1;
  
} 

void idx_delete( int n)
// Delete a bookmark and its references passing number (ie 0 in the case of IDX000)

{
  int bm;
  int loop;
  int count, diff;
  int entry;
  if(n<idx_no_marks)
  {
    bm = bmfind(idx_bm+idx_digit_three(n));
    if(bm!=0)
    { // Bookmark still exists
      bmdelete(bm);
    }              
    // Page Range?
    bm = bmfind(idx_bm+idx_digit_three(n)+"A");
    if(bm!=0)
    { // Bookmark still exists
      bmdelete(bm);
    }
  // We need to rename all the others that come above it
  // Reduce the count by 1
  // Remove the entry in Index
  // Remove the entries order if its the only reference
  
    if(n!=(idx_no_marks-1))
    {                                
    
    // Move Book Marks 
    
      loop = n;
      bm = bmcreate(idx_bm+idx_digit_three(n)); // Recreate our Index Entry
      while(loop <= (idx_no_marks-1))
      {                                                               
        // Find Entry 'n' and Entry n+1
        if (((bmfind(idx_bm+idx_digit_three(loop)))!=0)&&((bmfind(idx_bm+idx_digit_three(loop+1)))!=0))
        {                            
          // Move Entry n+1 to entry n
          setbmtobm(bmfind(idx_bm+idx_digit_three(loop)),bmfind(idx_bm+idx_digit_three(loop+1)));
          if(bmfind(idx_bm+idx_digit_three(loop+1)+"A")!=0)
          {
            bm = bmcreate(idx_bm+idx_digit_three(loop)+"A");
            setbmtobm(bm,bmfind(idx_bm+idx_digit_three(loop+1)+"A"));
            bmdelete(bmfind(idx_bm+idx_digit_three(loop+1)+"A"));
          }
        }
        else
        {
          if(bmfind(idx_bm+idx_digit_three(loop+1))==0)
          { 
            bmdelete(bmfind(idx_bm+idx_digit_three(loop)));
          }
        }
        loop = loop + 1;
      }; // Move Marks
      // Delete Maximum Book Mark
      bmdelete(bmfind(idx_bm+idx_digit_three(idx_no_marks-1)));      
      if(bmfind(idx_bm+idx_digit_three(idx_no_marks-1)+"A")!=0)  // Range marker!
      {
        bmdelete(bmfind(idx_bm+idx_digit_three(idx_no_marks-1)+"A"));
      }
    }
  
    
    loop=0; count = 0;
    // Prepare to delete Entry
    while(loop != (idx_no_marks-1))
    {
      
      if (mids(idx_index,loop*idx_ilen,idx_iolen)== mids(idx_index,n*idx_ilen,idx_iolen))
      {
        count = count + 1;
      }
      loop = loop + 1;
    }
  
    if(count == 1)
    // Only Reference to Index Entry
    {
   
      loop = stoi(mids(idx_index,n*idx_ilen,idx_iolen));
      idx_index=mids(idx_index,0,n*idx_ilen)+
                     mids(idx_index,(n+1)*idx_ilen,((idx_no_marks)-(n+1))*idx_ilen);
      idx_del_entry(loop);
    }
    else
    {
      idx_index=mids(idx_index,0,n*idx_ilen)
                +mids(idx_index,(n+1)*idx_ilen,((idx_no_marks)-(n+1))*idx_ilen);
    }
    idx_no_marks = idx_no_marks - 1;
  }
}
        
               
void idx_convert()
{ 
  int loop,bm1,bm2;
  string s;       

  // idx_offsets and idx_index need converting going for IDX1.00
  
  if(idx_version=="IDX1.00")
  {
    messagebox("Converting index from Version : "+idx_version);
    loop = 0; s= "";
    while(loop<idx_no_marks)
    {
      s = s + idx_digit_three(stoi(mids(idx_index,loop*4,3)))+
              mids(idx_index,(loop*4)+3,1);                  
      bm1=bmfind(idx_bm+mids(idx_digit_three(loop),2,3));
      bm2=bmcreate(idx_bm+idx_digit_three(loop));
      setbmtobm(bm2,bm1);
      bmdelete(bm1);  
      
      loop = loop + 1;

    }                                                           
    idx_index = s;                               
    loop = 0; s = "";
    while(loop<=idx_no_ent)
    {
      s = s + idx_digit_three(stoi(mids(idx_offsets,loop*3,3)));
      loop = loop + 1;
    }
    idx_offsets = s;
  }
  if(idx_version=="IDX1.01"||idx_version=="IDX1.02"||idx_version=="IDX1.03")
  {
    messagebox("Converting index from Version : "+idx_version);
    loop = 0; s= "";
    while(loop<idx_no_marks)
    {
      s = s + idx_digit_three(stoi(mids(idx_index,loop*6,5)))+
              mids(idx_index,(loop*6)+5,1);              
      messagebox(idx_bm+mids(idx_digit_three(loop),1,5));    
      bm1=bmfind(idx_bm+mids(idx_digit_three(loop),1,5));
      bm2=bmcreate(idx_bm+idx_digit_three(loop));
      setbmtobm(bm2,bm1);
      bmdelete(bm1);
      bm1=bmfind(idx_bm+mids(idx_digit_three(loop),1,5)+"A");
      if(bm1!=0)
      {
        bm2=bmcreate(idx_bm+idx_digit_three(loop)+"A");
        setbmtobm(bm2,bm1);
        bmdelete(bm1);  
      };
      loop = loop + 1;

    }                                                           
    idx_index = s;                               
    loop = 0; s = "";
    while(loop<=idx_no_ent)
    {
      s = s + idx_digit_three(stoi(mids(idx_offsets,loop*5,5)));
      loop = loop + 1;
    }
    idx_offsets = s;
  }
}

void idx_save()
{
 if(idx_no_marks>0)
 {
   tagwrites(currentfile(),idx_tag,idx_this_ver);
   tagwrites(currentfile(),idx_tag+1,idx_entries);
   tagwrites(currentfile(),idx_tag+2,idx_offsets);
   tagwrites(currentfile(),idx_tag+3,idx_index);
   tagwrites(currentfile(),idx_tag+4,idx_order);
   tagwrite(currentfile(),idx_tag+5,idx_no_ent,0);
   tagwrite(currentfile(),idx_tag+6,idx_no_marks,0);
 }
}

void idx_read_data(int v)
{                                                   

 if(tagexists(filefromview(v),idx_tag,0)==1)
 {
  tagreads(filefromview(v),idx_tag,idx_version);
  tagreads(filefromview(v),idx_tag+1,idx_entries);
  tagreads(filefromview(v),idx_tag+2,idx_offsets);
  tagreads(filefromview(v),idx_tag+3,idx_index);
  tagreads(filefromview(v),idx_tag+4,idx_order);
  idx_no_ent = tagread(filefromview(v),idx_tag+5,0);
  idx_no_marks = tagread(filefromview(v),idx_tag+6,0);
  if(idx_version!=idx_this_ver)
  {
    idx_convert();
    idx_save();
  }
 }
 else
 {
   idx_entries = "";
   idx_offsets = "";
   idx_index = "";
   idx_order = "";
   idx_no_ent = 0;
   idx_no_marks = 0;

 }
}



void idx_check_bmsupdate(int entry)
{
  int i,c;
  string bmname;

    i = 0; c=0;
    while(i<idx_no_marks && c==0)
    {
      bmname = mids(idx_index, i*idx_ilen, idx_iolen);
      if(bmname == idx_digit_three(entry))
      {
        c = c+1;
      }
      i = i + 1;
    }
    if((c==0))              
    {    
      messagebox("deleting Entry ");
      idx_del_entry(entry);
    //  idx_no_ent = idx_no_ent -1;
    }
}    



void idx_check_close(int handle)
{
 if(idx_window_p)
 {
  close_window(idx_window_p);
  delete_window(idx_window_p);
  idx_window_p=0;
 }
}



void idx_check_open(void)
{
 if(idx_window_p) idx_check_close(idx_window_p);

 idx_window_p=create_windowparent("IDX_Check",viewhandle(currentview()));

 addwindowhandler(7,idx_window_p,"idx_check_close");
 addwindowhandler(2,idx_window_p,"idx_check_close");

 display_window(idx_window_p,0,3);
 refresh_icon(0,idx_window_p,-1);
}






void idx_check_bms(int opt)
// Check Consistnecy (opt == 0 for user requested check)
{
   int    loop,i,c;
   string bmname;

  loop=0;               
  idx_read_data(currentview());
  if(opt==0)
  {
   idx_check_open();
  }  
  //messagebox("Check BMs");
  while(loop<idx_no_marks)
  {
    if(opt==0)
    {                          
      writeicon(idx_window_p,1,itos(loop));
      writeicon(idx_window_p,2,"");
    }
    bmname = idx_bm+idx_digit_three(loop);
    if(bmfind(bmname)==0)
    { 
      if(opt==0)
      {    
        writeicon(idx_window_p,2,"Deleting as marker is missing");
      }
      idx_delete(loop);
    }
    loop  = loop + 1;
  }                     
  idx_save();
           
  // Check text entries
  loop = 0;               
//  messagebox("Check Text");
  while(loop<idx_no_ent)
    {  
      if(opt==0)
      {
        writeicon(idx_window_p,1,itos(loop));
        writeicon(idx_window_p,2,"");
      }
    i = 0; c=0;
    while(i<idx_no_marks && c==0)
    {
      bmname = mids(idx_index, i*idx_ilen, idx_iolen);
      if(bmname == idx_digit_three(loop))
      {
        c = c+1;
      }
      i = i + 1;
    }
    if((c==0))              
    {    
      if(opt==0)
      {       
        writeicon(idx_window_p,2,idx_read_entry(loop));
      }
      idx_del_entry(loop);
    //  idx_no_ent = idx_no_ent -1;
      loop = - 1;
    }
    loop = loop + 1;
  }         
  idx_save();
  if(opt==0)
  {
    writeicon(idx_window_p,2,"Index Checked");
    refresh_icon(0,idx_window_p,-1);
    idx_check_close(idx_window_p);     
    messagebox("Index Checked - Please refresh Index Overview Window");
   
  }
}
             
string idx_style_des(string style)
{        
  string des;

  switch(schar(style,0))
  {
    case 65: des = "Italic and Bold"; break;
    case 66: des = "Bold"; break;
    case 73: des = "Italic"; break;
    case 32: des = "None"; break;
    default: des = "IDXSTYLE"+style;
  }         
  return des;
}

void idx_range_button(int h,int bm)
{
if((bmfind(idx_bm+idx_digit_three(bm)+"A"))!=0)
  {
    writeicon(h,26,"Unmark");
    
  }                          
  else
  {
    writeicon(h,26," Mark ");
  }
  refresh_icon(0,h,26);
}
void idx_review_init(int h,int bm)                         
// Setup review window (Handle == h, bookmark number bm)
{
  string entry;
   
  // Bookmark Stats 
  idx_bm_stat = schar(mids(idx_index,(bm*idx_ilen)+idx_iolen,idx_ilen-idx_iolen),0);
  if(idx_no_marks==0)
  {
    idx_bm_stat = 32; // Status byte - Bits 1 & 8 (Bold/Italic) Bit 6 always on
  }  
  if((idx_bm_stat&32)==0)
  {                      
    idx_bm_stat = idx_bm_stat + 32;
  }
  entry= idx_opt_e(idx_read_entry(stoi(mids(idx_index,bm*idx_ilen,idx_iolen))));
  writeicon(h,0,idx_main_e(idx_read_entry(stoi(mids(idx_index,bm*idx_ilen,idx_iolen)))));
  writeicon(h,1,idx_minor_e(idx_read_entry(stoi(mids(idx_index,bm*idx_ilen,idx_iolen)))));
  
  // Deal with See Entries bit
  if((entry/"S")>-1)
  {
    writeicon(h,17,mids(entry,1+(entry/idx_split_char),(slen(entry)-1-(entry/idx_split_char))));
   idx_ent_stat = 1;
  }                                                            
  else
  {
   writeicon(h,17,"");
   idx_ent_stat = 0;
   
    
  }
  //Format is /Main/Sub/IS/Hello Where I is the style (or space)
  if(mids(entry,0,1)!="S")
  {
    writeicon(h,16,mids(entry,0,1));
    if(" BIA"/mids(entry,0,1)>=0){writeicon(h,16,itos(" BIA"/mids(entry,0,1)));};
    writeicon(h,25,idx_style_des(readicon(h,16))); //idx_style_des(mids(entry,0,1)));
  }
  else
  {
    writeicon(h,16," ");
    writeicon(h,25,idx_style_des(" "));
  }  
  refresh_icon(0,h,25);
  select_icon(h,9,(idx_bm_stat&1)); // Bold
  select_icon(h,10,(idx_bm_stat&8)/8);  // Italic
  select_icon(h,22,(idx_ent_stat&1)); // Sub Entry
  idx_range_button(h,bm);
}

string idx_make_entry(int h)
{
  string entry;

  entry=idx_auto_cap(readicon(h,0))+idx_split_char+idx_auto_cap(readicon(h,1))+idx_split_char;
  entry=entry+readicon(h,16);
  if(idx_ent_stat==1)
  {
   entry=entry+"S"+idx_split_char+idx_auto_cap(readicon(h,17));
  }   
  return entry;
}

                  

void idx_review_initial(int s)
{
  idx_review_init(idx_window_r,0);
  writeicon(idx_window_r,2,itos(0)+idx_split_char+mids(idx_index,0*idx_ilen,idx_iolen));
  if((s==1)&&(idx_review_f==currentfile()))
  {
    setcarettobm(bmfind(idx_bm+idx_digit_three(0)));
    bmview(bmfind(idx_bm+idx_digit_three(0))); 
  }
}



void idx_close_r(int handle)
{
 if(idx_window_r)
 {
  close_window(idx_window_r);
  delete_window(idx_window_r);
  idx_window_r=0;
  idx_review_open=0;
 }
}



void idx_review_it(int v)
{                

 if(idx_window_r) idx_close_r(idx_window_r);

 if(idx_use_big_rev==1) //1.05
 {                              
  idx_window_r=create_windowparent("IDX_Review2",viewhandle(currentview()));
 }
 else
 {      
  idx_window_r=create_windowparent("IDX_Review",viewhandle(currentview()));
 }

 addwindowhandler(7,idx_window_r,"idx_close_r");
 addwindowhandler(0,idx_window_r,"idx_review_click");
 addwindowhandler(2,idx_window_r,"idx_close_r");


  // Ensure the data is initialised on call to review_click
  idx_review_f = -1;
  idx_read_data(v);
  idx_review_f = filefromview(v);
  idx_active_view=v;
  writeicon(idx_window_r,2,itos(0));  
  // Goto Index 0         
  
  idx_review_initial(1);

  display_window(idx_window_r,0,2);
  idx_review_open = 1;
  insert_caret(idx_window_r,0);
}

void idx_type_it(void)
{                 
 int loop;

 idx_read_data(currentview());
 
 messagebox("Preparing Index Generation - Please Wait");
// swi13(0x406c0,0,0,0); 
 if(idx_no_marks>0)
 {       
   idx_order="";            
   loop = 1;
   while(loop<(idx_no_marks+2))
   {
     idx_order = idx_order + idx_digit_three(loop);
    loop = loop + 1;
   }             
// swi13(0x406c1,0,0,0);
   messagebox("Sort Text and BMs");
   idx_sort();           
   messagebox("Sort BMs");
   idx_bm_sort();
   idx_locate_cursor();
   idx_type_index(); 
   idx_save();
 }
}                                         



void idx_close_i(int handle)
{
 if(idx_window_i)
 {
  close_window(idx_window_i);
  delete_window(idx_window_i);
  idx_window_i=0;
 }
}




void idx_info_it(void)
{
 if(idx_window_i) idx_close_i(idx_window_i);

 idx_window_i=create_windowparent("IDX_Info",viewhandle(currentview()));

 addwindowhandler(7,idx_window_i,"idx_close_i");
 addwindowhandler(2,idx_window_i,"idx_close_i");

 idx_read_data(currentview());
 if(idx_no_marks>0)
 {
  writeicon(idx_window_i,3,idx_version);
  writeicon(idx_window_i,4,itos(idx_no_ent));
  writeicon(idx_window_i,5,itos(idx_no_marks));
 }
 else
 {
  writeicon(idx_window_i,3,idx_this_ver);
  writeicon(idx_window_i,4,"0");
  writeicon(idx_window_i,5,"0");
 }
 display_window(idx_window_i,0,2);

 setfocus(idx_window_i);
}




int idx_menu_sub(int open)
{
  return(idx_menu_h);
}





void idx_close_o(int handle)
{
 if(idx_window_o)
 {
  close_window(idx_window_o);

  delete_window(idx_window_o);
  idx_window_o=0;
 }
}



void idx_gopt_click(int h, int i, int b, int x,int y)
{            
  switch(i)
  {
    case 0 : idx_inc_chp = idx_inc_chp^1;
             break;
    case 101 : idx_pg_tab  = idx_pg_tab^1;
             break;
    case 102 : idx_cap_e   = idx_cap_e^1;
             break;
    case 3 : idx_miss_s = idx_miss_s^1;
             break;               
    case 12 : idx_split_e = idx_split_e^1;
              break;
    case 13 : idx_prompt_del = idx_prompt_del^1;
              break;
    case 14 : idx_ignore_c = idx_ignore_c^1;
              break;
    case 5 : idx_save_gopt();
	case 1 :
    case 2 : idx_close_o(idx_window_o);
             break;

  }
  idx_up_gopt();
  
}








void idx_gopt_it(int parent)
{
 if(idx_window_o) idx_close_o(idx_window_o);

 idx_window_o=create_windowparent("IDX_Opt",parent);

 addwindowhandler(7,idx_window_o,"idx_close_o");
 addwindowhandler(2,idx_window_o,"idx_close_o");
 addwindowhandler(0,idx_window_o,"idx_gopt_click");

 idx_up_gopt();
 display_window(idx_window_o,0,2);
 insert_caret(idx_window_o,7);
}





void idx_review_click(int h, int i, int b, int x,int y)
{                         
  int bm, temp, temp2,temp3,temp4,temp5,temp6;                        
  string  entry,find;         
  int     loop,new_ent;
  int     goto_idx;   
  int     up_txt;
              
  goto_idx=1;
  if(idx_review_f!=currentfile())
  {
    idx_review_f = currentfile();
    idx_read_data(currentview());
    writeicon(h,2,itos(0));
    setcarettobm(bmfind(idx_bm+idx_digit_three(0)));
    bm = 0;
    idx_review_init(h,bm);
    i = -1;
  }
  bm = stoi(readicon(h,2));
  if(i==3)
  { // Up Arrow
    if(bm<(idx_no_marks-1))
    {
      bm = bm + 1;
      idx_review_init(h,bm);
    }
  }
  if(i==4)
  { // Down Arrow
    if(bm>0)
    {
      bm = bm - 1;
      idx_review_init(h,bm);
    }
  }  
  if(i==5)
  {  if(bm>=0)
     {
       idx_delete(bm);
       idx_save();    
       idx_check_bms(1);
       if(bm>(idx_no_marks-1))
       {
         bm = idx_no_marks-1;
         
       }
       idx_review_init(h,bm);
     }
  }                  
  if(i==9)
  {         
    goto_idx=0;
    idx_bm_stat = (idx_bm_stat^1);
    select_icon(h,9,(idx_bm_stat&1));
  }
  if(i==10)
  {    
    goto_idx=0;
    idx_bm_stat = (idx_bm_stat^8);
    select_icon(h,10,(idx_bm_stat&8)/8);
  }
  if(i==11)
  {  // Update BM stat
     idx_index = mids(idx_index,0,(bm*idx_ilen)+idx_iolen)+chars(idx_bm_stat)+
                 mids(idx_index,(bm+1)*idx_ilen,((idx_no_marks)*idx_ilen)-(bm+1)*idx_ilen);
     idx_save();
  }
  if(i==12)
  {
     setbmtocaret(bmfind(idx_bm+idx_digit_three(bm)));
     if((bmfind(idx_bm+idx_digit_three(bm)+"A"))!=0)
     {
      if(bmcmp(bmfind(idx_bm+idx_digit_three(bm)),bmfind(idx_bm+idx_digit_three(bm)+"A"))==1)
      {
        temp2=bmcreate(idx_bm+"B1");
        setbmtobm(temp2,bmfind(idx_bm+idx_digit_three(bm)+"A"));
        setbmtobm(bmfind(idx_bm+idx_digit_three(bm)+"A"),bmfind(idx_bm+idx_digit_three(bm)));
        setbmtobm(bmfind(idx_bm+idx_digit_three(bm)),temp2);
        bmdelete(temp2);
      }
    }
  }             
  if(i==22)
  {            
    goto_idx=0;
    idx_ent_stat = (idx_ent_stat^1);
    select_icon(h,22,idx_ent_stat);
  }            
  if(i==13)
  {
  // Update Text
    //entry=idx_auto_cap(readicon(h,0))+idx_split_char+idx_auto_cap(readicon(h,1))+idx_split_char;
    //entry=entry+readicon(h,16);
   // if(idx_ent_stat==1)
   // {
   //    entry=entry+"S"+idx_split_char+idx_auto_cap(readicon(h,17));
   // }     
    entry=idx_make_entry(h);
    up_txt = stoi(mids(idx_index,bm*idx_ilen,idx_iolen));
    if(idx_read_entry(stoi(mids(idx_index,bm*idx_ilen,idx_iolen)))!=entry)
    {       
      new_ent=idx_add_entry(entry);
      idx_index = mids(idx_index,0,(bm*idx_ilen))+
                  idx_digit_three(new_ent)+chars(idx_bm_stat)+
                  mids(idx_index,(bm+1)*idx_ilen,((idx_no_marks)*idx_ilen)-(bm+1)*idx_ilen);  
      idx_save(); 
//      idx_check_bms(1);  // No messages
      idx_check_bmsupdate(up_txt);
      // We really only need to check if references exist to the old text and if not delete the text
     
    }
    else
    { 
      //messagebox("Unchanged");
    }
    idx_review_init(h,bm);
  }
  if(i==14)
  {
  // Add Entry
//   entry=idx_auto_cap(readicon(h,0))+idx_split_char+idx_auto_cap(readicon(h,1))+idx_split_char;
//    entry=entry+readicon(h,16);
//    if(idx_ent_stat==1) 
//    {
//       entry=entry+"S/"+idx_auto_cap(readicon(h,17));
//    }     
    entry=idx_make_entry(h);
    if(idx_read_entry(stoi(mids(idx_index,bm*idx_ilen,idx_iolen)))!=entry)
    {
      new_ent=idx_add_entry(entry);
      idx_index = (mids(idx_index,0,idx_no_marks*idx_ilen))
                  +(idx_digit_three(new_ent))
                  +chars(idx_bm_stat);
      idx_no_marks = idx_no_marks + 1;
      temp=bmcreate(idx_bm+idx_digit_three(idx_no_marks-1));
      setbmtocaret(temp);
      idx_save();
    }       
    else
    {                   
      //messagebox("The Same");
      idx_index = mids(idx_index,0,idx_no_marks*idx_ilen)
                  + (mids(idx_index,bm*idx_ilen,idx_iolen))
                  +chars(idx_bm_stat);
      idx_no_marks = idx_no_marks + 1;
      temp=bmcreate(idx_bm+idx_digit_three(idx_no_marks-1));
      setbmtocaret(temp);
      idx_save();
    } 
    bm=idx_no_marks-1;
    idx_review_init(h,bm);
  }
  if(i==19)
  {
  // Style Down
    entry=readicon(h,16);
    switch(schar(entry,0))
    {
      case 32 : entry = "B"; break;
      case 66 : entry = "I"; break;
      case 73 : entry = "A"; break;
      case 65 : entry = " "; break;
      default : if(stoi(entry)>0){entry = itos((stoi(entry)-1));};
     }
     writeicon(h,16,entry);
     writeicon(h,25,idx_style_des(entry));
     refresh_icon(0,h,25);
  }
  
  if(i==20)
  {
  // Style Up
    entry=readicon(h,16);
    switch(schar(entry,0))
    {
      case 32 : entry = "A"; break;
      case 65 : entry = "I"; break;
      case 73 : entry = "B"; break;
      case 66 : entry = " "; break;
      default : if(stoi(entry)<9){entry = itos((stoi(entry)+1));};
      
     }
     writeicon(h,16,entry);
     writeicon(h,25,idx_style_des(entry));
     refresh_icon(0,h,25);
  }
  
  if(i==21)
  {
  // Update ALL Text
 //   entry=idx_auto_cap(readicon(h,0))+idx_split_char+idx_auto_cap(readicon(h,1))+idx_split_char;
 //   entry=entry+readicon(h,16);
 //   if(idx_ent_stat==1)
 //   {
 //      entry=entry+"S"++idx_split_char+idx_auto_cap(readicon(h,17));
 //   }                    
    entry=idx_make_entry(h);
    new_ent=idx_add_entry(entry);
    loop = 0; 
    entry = mids(idx_index,bm*idx_ilen,idx_iolen);
  //  messagebox("IDX INDEX"+idx_index);
    while(loop<idx_no_marks)
    {                 
  //    messagebox(mids(idx_index,loop*idx_ilen,idx_iolen));
      if(mids(idx_index,loop*idx_ilen,idx_iolen)==entry)
      {                          
        // Back bit + new number + BM style + rest  of index
        idx_index = mids(idx_index,0,(loop*idx_ilen))+
                idx_digit_three(new_ent)+
                mids(idx_index,(loop*idx_ilen)+idx_iolen,idx_ilen-idx_iolen)+
                mids(idx_index,(loop+1)*idx_ilen,((idx_no_marks)*idx_ilen)-(loop+1)*idx_ilen);  
       
      }
      loop = loop + 1;
    }
    
    idx_save();
    idx_check_bms(0);
    idx_review_init(h,bm);
  }
  if(i==23)
  {
  // Copy Text from Cursor
    if(zoneorder()!=0)
    {        
      goto_idx=0;
      temp=bmcreate(idx_bm+"B1");
      temp2=bmcreate(idx_bm+"B2");
      setbmtozone(temp,temp2);
      entry="";
      while(bmcmp(temp,temp2)!=0)
      {                  
        entry=entry+chars(bmchar(temp));
        bmmove(temp,1,0);
      }    
      while((mids(entry,0,1)==" ")&&(slen(entry)>0))
      {
        entry = mids(entry,1,slen(entry)-1);
      }
      while((mids(entry,slen(entry)-1,1)==" ")&&(slen(entry)>0))
      {
        entry = mids(entry,0,slen(entry)-1);
      }
      // Splitting Here!
      if(((entry/" ")>0)&&(idx_split_e))
      {
        writeicon(h,0,mids(entry,0,entry/" "));
        writeicon(h,1,mids(entry,(entry/" ")+1,slen(entry)-(entry/" ")-1));
      }
      else
      {
        writeicon(h,0,entry);
        writeicon(h,1,"");
      }
      bmdelete(temp);
      bmdelete(temp2);

    }        
  }                   
  
  if(i==31)
  {
  // Swap
  entry=readicon(h,1);
  writeicon(h,1,readicon(h,0));
  writeicon(h,0,entry);
  goto_idx=0;
  }                    

  if((i==30)||(i==24))
  {
    find=readicon(h,28);
    temp=bmcreate(idx_bm+"B1");
    temp2=bmcreate(idx_bm+"B2");
    setbmtocaret(temp);
    if(i==24)
    {
      bmstartscan();
    }
      temp3=bmnextstory(temp);
   
    loop=bmsearch(temp,temp2,find,0);

    if(loop!=0)
    {
     while((temp3==0)&&(loop!=0))
     {
       temp3=bmnextstory(temp);  
       setbmtobm(temp2,temp);
       if(temp3==0)
       {
        loop=bmsearch(temp,temp2,find,0);
       }
      }
     }  
    if((loop==0))
    {   
      setcarettobm(temp2);
      bmview(temp2);
      setzonetobm(temp); 
      setbmtobm(temp,temp2);
      goto_idx = 0;
    }
    bmdelete(temp);
    bmdelete(temp2);
  
 } 
  if(i==32)
  {
  // Split Text
  entry=readicon(h,0);
  if((entry/idx_split_char)>0)
  {
    writeicon(h,0,mids(entry,0,entry/idx_split_char));
    writeicon(h,1,mids(entry,(entry/idx_split_char)+1,slen(entry)-(entry/idx_split_char)-1));
  }
  }
  if(i==26)
  { 
    if((bmfind(idx_bm+idx_digit_three(bm)+"A"))==0)
    {
      temp=bmcreate(idx_bm+idx_digit_three(bm)+"A");
      setbmtocaret(temp);
      if(bmcmp(bmfind(idx_bm+idx_digit_three(bm)),temp)==1)
      {
        temp2=bmcreate(idx_bm+"B1");
        setbmtobm(temp2,temp);
        setbmtobm(temp,bmfind(idx_bm+idx_digit_three(bm)));
        setbmtobm(bmfind(idx_bm+idx_digit_three(bm)),temp2);
        bmdelete(temp2);
      }
    }
    else
    {
      bmdelete((bmfind(idx_bm+idx_digit_three(bm)+"A")));
    }                   
    idx_range_button(h,bm);
  }    
  if(i==34)
  { goto_idx=0;
    setcarettobm(bmfind(idx_bm+idx_digit_three(bm)));
    setzonetobm(bmfind(idx_bm+idx_digit_three(bm)+"A"));
  }   
  if(i==35)
  { //Big Window - Create
    idx_type_it();
  }               
  if(i==36)
  {     
    idx_check_bms(0);
  }
  if(i==37)
  {
   idx_gopt_it(h);
  }
  if(i==27)
  {
    find=readicon(h,28); //Search String   
    if(find=="")
    {
      find = readicon(h,0)+" "+readicon(h,1);
    }
    if(readicon(h,0)=="")
    {
      writeicon(h,0,find);
      writeicon(h,1,"");
    }
    entry=idx_make_entry(h); //Entry String
    temp5=bmcreate(idx_bm+"RTN");            
    setbmtocaret(temp5);
    temp=bmcreate(idx_bm+"B1");
    temp2=bmcreate(idx_bm+"B2");
    setbmtocaret(temp);
    bmstartscan();        
    temp3=bmnextstory(temp);
    loop = 0; temp3=0;
    // Need an Outer Loop Here
    while((loop==0)&&(temp3==0))
    {
      loop=-1;
      loop=bmsearch(temp,temp2,find,0); // find in current story
      
      if(loop!=0)
      {
        while((temp3==0)&&(loop!=0))
        {
          temp3=bmnextstory(temp);  // Try Other Stories       
          setbmtobm(temp2,temp);
          if(temp3==0)
          {
            loop=bmsearch(temp,temp2,find,0);
          }
        }
      }  
         
      if(loop==0)
      { 
     //   messagebox(itos(idx_bm_stat));
        if(idx_read_entry(stoi(mids(idx_index,bm*idx_ilen,idx_iolen)))!=entry)
        {
         new_ent=idx_add_entry(entry);
 
         idx_index = (mids(idx_index,0,idx_no_marks*idx_ilen))
                   +(idx_digit_three(new_ent))
                   +chars(idx_bm_stat);
        }
        else
        {
        idx_index = mids(idx_index,0,idx_no_marks*idx_ilen)
                  + (mids(idx_index,bm*idx_ilen,idx_iolen))
                  +chars(idx_bm_stat);
        }
        bm=idx_no_marks;
        idx_no_marks = idx_no_marks + 1;  
        temp4=bmcreate(idx_bm+idx_digit_three(idx_no_marks-1));
        setbmtobm(temp4,temp);
        bmview(temp4);
        setcarettobm(temp2);
        setbmtobm(temp,temp2);
        idx_save();
       }       
 
    }
    setcarettobm(temp5);
    bmview(temp5);
    bmdelete(temp5);
    goto_idx=0;
    bmdelete(temp);
    bmdelete(temp2);           

  
 } 

  writeicon(h,2,itos(bm)+idx_split_char+mids(idx_index,bm*idx_ilen,idx_iolen));
  if(goto_idx==1)
  {
    setcarettobm(bmfind(idx_bm+idx_digit_three(bm)));
    bmview(bmfind(idx_bm+idx_digit_three(bm))); 
  }
}    





                  

void idx_caret_move(int u, int v, int g)    
{                                           
    
    if(g==1)
    {
      // Update window to represent current view
      if(idx_active_view!=v)
      {                     
        if(idx_review_open!=0)
        {
          idx_review_it(v);
        }
      }                                         
    }
    else
    {
      idx_active_view = 0;
    }
  
}                   



void idx_caret_premove(int u, int v)
// No longer used
{
  idx_caret_move(u,v,1);
}       

int idx_st_menu_clk(int n, int s)
// When Style selected from Conversion window
{                                        
  string s1;
  menudefstring(idx_style_convert_menu,n,4,s1);
  writeicon(idx_window_con,101,s1);
}

void idx_convert_menu()
// Display Styles in a menu
{
  int handle =0, r =1, f =-1, l = 0; 
   string gotname;
   if(idx_style_convert_menu!=-1)
   {
      delete_menu(idx_style_convert_menu);
   }
   idx_style_convert_menu=create_menu("{IDX_07}");     
   r=1;
   f=-1;
   for(handle=0;((r!=0)&&(f==-1)); handle++)
   {
    r=getuserstyle(handle,gotname,0);
    if((r!=0)&&(gotname!="Bodytext"))
    {
      addentry_menu(idx_style_convert_menu,"idx_st_menu_clk","","","",gotname);
      l++;
    }
   }                                      
   if(l>0)
   {
   open_menu(idx_style_convert_menu);
   }
}




void idx_do_convert(int mode)
{ 
string s;
string index_entry,index_entry1,index_entry2;                                   
int page;
int    styl_no,next_s, new_ent, count;
int bm,bms,bme;           


 idx_read_data(currentview());
 count = 0;
// Read Styles and Create Index        
if(readicon(idx_window_con,1)!="")
{
  s=readicon(idx_window_con,1);
  styl_no=idx_fstyle(s);
 // messagebox(itos(styl_no));
  // Get ready to find entries - start by marking current location  
  bm=bmcreate(idx_bm+"CRT"); 
  setbmtocaret(bm);

  bmstartscan();              
  //Goto start
  type("{home}{C_CUp}{CRight}");
  bms = bmcreate(idx_bm+"CS"); // Convert Start
  setbmtocaret(bms); 
  next_s = bmnextstory(bms);
  setcarettobm(bms);

  writeicon(idx_window_con,10,itos(bmpage(bms)+1));
  page = bmpage(bms);
  writeicon(idx_window_con,11,itos(idx_no_marks));
  do
   
  {                
    while(caretchar())
    {
      setcarettobm(bms);
      if(page!=(bmpage(bms)))
      {
      writeicon(idx_window_con,10,itos(bmpage(bms)+1));
      page=bmpage(bms);
      }
      
      if(iscurrentstyle(0)&&iscurrentstyle(styl_no))
      { 
        index_entry="";
        while(iscurrentstyle(0)&&iscurrentstyle(styl_no)&&caretchar())
        {                   
          if(mode==1)       
          {
            index_entry = index_entry + chars(caretchar());
          }
          else
          {
            index_entry = index_entry + chars(prevchar());
          }
          type("{CRight}");
        }
     //   messagebox(index_entry);
        if(((index_entry/" ")>0)&&(idx_split_e))
        {
          index_entry1=mids(index_entry,0,index_entry/" ");
          index_entry2=mids(index_entry,(index_entry/" ")+1,slen(index_entry)-(index_entry/" ")-1);
        }
        else
        {
          index_entry1=index_entry;
        }
        if(slen(index_entry1)>40)
        {
          index_entry1 = mids(index_entry,0,39);
        }
        if(slen(index_entry2)>40)
        {
          index_entry2 = mids(index_entry2,0,39);
        }
        index_entry=idx_auto_cap(index_entry1)+idx_split_char+idx_auto_cap(index_entry2)+idx_split_char+"0";
        new_ent=idx_add_entry(index_entry);
        count = count + 1;
        idx_index = (mids(idx_index,0,idx_no_marks*idx_ilen))
                   +(idx_digit_three(new_ent))
                   +" ";      
        idx_no_marks = idx_no_marks + 1;  
        bme=bmcreate(idx_bm+idx_digit_three(idx_no_marks-1));
        setbmtobm(bme,bms);
        writeicon(idx_window_con,10,itos(bmpage(bme)+1));
        writeicon(idx_window_con,11,itos(idx_no_marks));
     //   bmmove(bme,0,0);
        type("{CLeft}");
      }
      type("{CRight}"); 
      setbmtocaret(bms);
    }       
    next_s=bmnextstory(bms);
  //  messagebox("Next Story:"+itos(next_s));
    type("{home}{C_CUp}{CRight}");
   } while(!next_s);
   setcarettobm(bm);
   bmdelete(bm);
   bmdelete(bms);     
   idx_save();
   close_window(idx_window_con);
   messagebox(itos(count)+" Index Entries Created");
}
else
{
  messagebox("Please Select a Style to Convert");
}
}





void idx_close_con(int handle)
{
 if(idx_window_con)
 {
  close_window(idx_window_con);

  delete_window(idx_window_con);
  idx_window_con=0;
 }
}


void idx_convert_click(int h, int i, int b, int x,int y)
{

 switch(i)
 {                                  
    case 2:
	       idx_close_con(idx_window_con);
	       break;

    case 3:
	       idx_do_convert(1);
		   break;

    case 5:
	       idx_do_convert(2);
		   break;

    case 0:
	        idx_convert_menu();
			break;
 }
}



void idx_convert_it(void)
{
 if(idx_window_con) idx_close_con(idx_window_con);

 idx_window_con=create_windowparent("IDX_Convert",viewhandle(currentview()));
 addwindowhandler(0,idx_window_con,"idx_convert_click");
 addwindowhandler(7,idx_window_con,"idx_close_con");
 addwindowhandler(2,idx_window_con,"idx_close_con");

 writeicon(idx_window_con,101,""); // No Style Selected
 writeicon(idx_window_con,10,"");
 writeicon(idx_window_con,11,"");
 display_window(idx_window_con,0,2);
 setfocus(idx_window_con);
}






int idx_menu_do(int entry, int subcode)
{
  switch(entry)
  {
    case 0: idx_info_it();
            break;
    case 1: idx_review_it(currentview());
            break;
    case 2: idx_type_it();
            break;
    case 3: idx_check_bms(0);
            break;
    case 4: idx_gopt_it(viewhandle(currentview()));
            break;
    case 5: idx_convert_it();
            break;
   }
   return(0);                              
}                      






                                                         

void idx_initialise()
{
 string temp;  
 int    work;

 idx_review_f=-1;
 idx_review_open=0;
 idx_active_view=0;

 idx_set_gopt();

 script_menu_initialise();
 script_menu_insert("","","idx_menu_sub","","{IDX_00}");

 idx_menu_h = create_menu("{IDX_00}");
 addentry_menu(idx_menu_h,"idx_menu_do","","",idx_info_key,"{IDX_01}");
 addentry_menu(idx_menu_h,"idx_menu_do","","",idx_review_key,"{IDX_02}");
 addentry_menu(idx_menu_h,"idx_menu_do","","",idx_type_key,"{IDX_03}");
 addentry_menu(idx_menu_h,"idx_menu_do","","","","{IDX_04}");
 addentry_menu(idx_menu_h,"idx_menu_do","","","","{IDX_05}");
 addentry_menu(idx_menu_h,"idx_menu_do","","","","{IDX_06}");

  
 addeventhandler(0x215,215,"idx_caret_move");

 bm_hide("IDX");
}



int idx_checkcount(int bms, int bme)
{
  int bmt;
  int loop;           
  int count;              
  int status;                                  

  bmt = bmcreate(idx_bm+"BT");
  count = 0;
  
  setbmtobm(bmt,bms);
// Fix for Lockup (thanks to Roger Nobel)
  status = 1;  
  while(bmcmp(bmt,bme)<0 && status) 
  {
    loop = 0;
    while(loop<idx_no_marks)
    {
      if(bmcmp(bmt,bmfind(idx_bm+idx_digit_three(loop)))==0)
      {     
        count +=1;
      }
      loop+=1;
    }
    status = bmmove(bmt,1,0);
  }
  
  bmdelete(bmt);  
  return count;  
}



void idx_checkdelete(int bms, int bme,int conf)
{
  int bmt;
  int loop;  
  int status;                       
  
  bmt = bmcreate(idx_bm+"BT");
  setbmtobm(bmt,bms);
  status = 1;
  while(bmcmp(bmt,bme)<0 && status)
  {
    loop = 0;
    while(loop<idx_no_marks)
    {
      if(bmcmp(bmt,bmfind(idx_bm+idx_digit_three(loop)))==0)
      {                                        
         if(conf==1)
         {
           if(confirmparent("Delete Index Entry : "+itos(loop),idx_window_r)==1)
           {
            idx_delete(loop); 
            idx_save();    
            idx_check_bms(1);

			if(idx_window_r)
			{
             if(loop>idx_no_marks)
             {
               writeicon(idx_window_r,2,itos(loop-1));
               idx_review_init(idx_window_r,loop);
             }
             else
             { 
               writeicon(idx_window_r,2,itos(loop));
               idx_review_init(idx_window_r,loop);
             }
			}
           }
         }
         else
         {
            idx_delete(loop);
            idx_save();
            idx_check_bms(1);
            if(idx_window_r)
			{
             if(loop>idx_no_marks)
             {
              writeicon(idx_window_r,2,itos(loop-1));
              idx_review_init(idx_window_r,loop);
             }
             else
             { 
              writeicon(idx_window_r,2,itos(loop));
              idx_review_init(idx_window_r,loop);
             }
			}
         }
      }
      loop+=1;
    }                        
// Fix for Lockup
    status = bmmove(bmt,1,0);
  }
  
  bmdelete(bmt);   
 
   
}

int idx_bmdelfn(int cut)
{            
  int bms, bme, bmt;    
  int loop,stat;        
 
  if(zoneorder()!=0)
  {
    idx_nodelete=0;
  }
  if(idx_nodelete!=1)
  {
  bms = bmcreate(idx_bm+"B1");
  bme = bmcreate(idx_bm+"B2");
  setbmtozone(bms,bme);
  idx_checkdelete(bms,bme,1);
  stat=idx_checkcount(bms,bme);
  bmdelete(bms); bmdelete(bme);
  if(stat>0)return -1; else return 0;

  }
  idx_nodelete = 0;
}


int idx_keypress(int key)
{
  int bms, bme;
     

//  if(activetype(TEXTFRAME)<=1) return key;
  
  bms=bmcreate(idx_bm+"B1");
  bme=bmcreate(idx_bm+"B2");
  idx_nodelete = 1;

  switch(key)
  {
    case 127:    // delete <
    case 6664 :
      
      setbmtocaret(bms); setbmtocaret(bme); bmmove(bms,0,0);
      idx_checkdelete(bms,bme,idx_prompt_del);
      bmdelete(bms); bmdelete(bme);
      return key;
      break;

    case 395:    // delete >
      setbmtocaret(bms); setbmtocaret(bme); bmmove(bms,1,0);
      idx_checkdelete(bms,bme,idx_prompt_del);
      bmdelete(bms); bmdelete(bme);
      return key;
      break;
 
    case 2175:   // delete word before cursor
    case 2568:
      setbmtocaret(bms); setbmtocaret(bme); 
      bmmove(bms,0,5); bmmove(bme,0,5); bmmove(bme,1,1);
      idx_checkdelete(bms,bme,idx_prompt_del);
      bmdelete(bms); bmdelete(bme);
      return key;
      break;

    case 411:    // delete word at cursor
      setbmtocaret(bms); setbmtocaret(bme); 
      bmmove(bms,0,1); bmmove(bme,1,1);
      idx_checkdelete(bms,bme,idx_prompt_del);
      bmdelete(bms); bmdelete(bme);
      return key;
      break;

    
    default:
      idx_nodelete = 0;
    //  messagebox("Delete");
      bmdelete(bms); bmdelete(bme);
      return key;
    
  }
}  

void main(void)
{ 

 // Examples ... for my reference!
 // idx_entries = "Apple/RedApple/GreenBanana/Elephant/Indian1Elephant/African/I"; // Entries
 // idx_order = "001002003004005006007008"; // Entries in Alpha Order
 // idx_offsets = "000009020027043061"; // Offsets in entries for each entry (1 more than entry..)
 // idx_index   = "001 004 002!003)005 000 006 "; // Index Markers (Offset = BM number)
  
  

  idx_initialise();

  
}
