/*->c.dbfill */
/* Arranged code */



#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"

#include "transform.h"

#include "xprocess.h"



#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "sp.h"
#include "task.h"
#include "xhelp.h"
#include "trans.h"
#include "dbhi.h"
#include "key.h"
#include "temp.h"
#include "avl.h"
#include "deb.h"

#include "xext.h"



#include "constants.h"
#include "str.h"

#include "xredraw.h"
#include "curve.h"
#include "object.h"

#include "file.h"
#include "view.h"
#include "viewo.h"
#include "viewr.h"
#include "mhi.h"
#include "undo.h"

#include "xxcolour.h"
#include "xcolour.h"
#include "colsep.h"

#include "units.h"

#include "select.h"

#include "dbscale.h"






#include "fill.h"
#include "filllink.h"
#include "fillobject.h"
#include "filltool.h"

#include "dbfill.h"



/****************************************************************************/


static int             fillapply;

static fillblockstr  * xfillp;
static filldatastr   * xfilldata;

static fillstr         xfill;

static int             cfillobject;




/* tagged to USFILLS */
/* this function is always called last in undo/redo */

os_error * unfillselections(filestr * file)
{
 int                 selectn;
 selectedobjectstr * selection;
 filestr           * selfile;
 int                 selpage;
 int                 selsect;


 selfile=getselection(&selpage,&selsect,&selection,&selectn);

 vxend(file,VRBACK,selpage,selsect);

 event(EVENT_FILLCHANGE1,file,0);

 return(undowritefn(file,USFILLF,NULL,0));
}


/* tagged to USFILLF */

os_error * unfillselectionf(filestr * file)
{

 event(EVENT_FILLCHANGE0,file,0);

 vxstart(file);

 return(undowritefn(file,USFILLS,NULL,0));
}



/* tagged to USFILL */

static os_error * unfill(filestr * file)
{
 os_error    * err;
 undofillstr   undofill;
 fillstr       tempfill;
 int           message2;

 err=undoread(file,&undofill,sizeof(undofillstr));

 message2=OM_SETFILL;
 objectmessage2(undofill.object,file,&message2,&undofill.oldfill);

 tempfill=undofill.newfill;
 undofill.newfill=undofill.oldfill;
 undofill.oldfill=tempfill;

 undowritefn(file,USFILL,&undofill,sizeof(undofill));

 return(err);
}


static os_error * unfillscrap(filestr * file)
{
 os_error      * err;
 undofillstr     undofill;
 fillblockstr  * fillp;
 fillobjectstr * fob;
 int             filltype;


 err=undoread(file,&undofill,sizeof(undofillstr));
 if(!err)
 {
  if(undofill.oldfill.fill)
  {
   fob=(fillobjectstr*)fob_find(undofill.oldfill.fill,file);
   if(fob)
   {
    filltype=fob->filltype;

    fillp=findfillblock(filltype);
    if(fillp)
    {
     if(fillp->fdfn) err=fillp->fdfn(&undofill.oldfill,file);
     else            err=fob_delete(undofill.oldfill.fill,file);
    }
   }
  }
 }

 return(err);
}




static filltoolstr * xfilltool;


static os_error * fillobjectfn(objhdrstr * obj,filestr * file,int * message)
{
 os_error   * err;
 fillstr      newfill;
 fillstr      oldfill;
 int          message2;
 int          key;
 undofillstr  undofill;
 filltoolstr  lfill;
 int          master;
 objectbitstr bits;

 key=obj->key;

 err=objectmaster(key,file,&master,&bits);
 if(!err)
 {
  if(!master || bits.local)
  {
   message2=OM_GETFILL;
   objectmessage2(key,file,&message2,&oldfill);
   if(!message2)
   {
    if(fillapply && xfilltool)
    {
     if(xfillp->apply)
     {
      lfill=*xfilltool;
      fill2local(file,key,&lfill);
      err=xfillp->apply(file,&lfill,&newfill,NULL);
     }
    }
    else
    {
     err=xfillp->create(file,xfilldata,&newfill,&oldfill);
    }

    message2=OM_SETFILL;
    objectmessage2(key,file,&message2,&newfill);

    undofill.object=key;
    undofill.newfill=newfill;
    undofill.oldfill=oldfill;

    undowritefn(file,USFILL,&undofill,sizeof(undofill));
   }
  }
 }

 return(err);

 USE(message);
}





static os_error * fillselection(filestr * file,fillstr * fill,
                                filldatastr * data,int filltype)
{
 os_error          * err;
 int                 selectn;
 selectedobjectstr * selection;
 filestr           * selfile;
 int                 selpage;
 int                 selsect;
 int                 message;
 filltoolstr         tool;


 err=NULL;

 xfillp=findfillblock(filltype);
 xfilldata=data;


 if(xfillp)
 {
  selfile=getselection(&selpage,&selsect,&selection,&selectn);
  if(selfile==file)
  {
   err=modfile(selfile,selsect);
   if(!err)
   {
    xfilltool=NULL;

    if(fillapply && cfillobject)
    {
     if(xfillp->tool) xfillp->tool(file,&tool,NULL);
     fill2global(file,cfillobject,&tool);
     xfilltool=&tool;
     tool.process=data->process;
    }

    err=undostart(selfile);
    if(!err)
    {
     unfillselectionf(selfile);

     message=OM_FUNCTION;

     selectionmessage(file,&message,(void*)fillobjectfn);

     unfillselections(selfile);

     undoend(selfile);
    }
   }
  }
 }

 return(err);

 USE(fill);
}









static os_error * remfillobjectfn(objhdrstr * obj,filestr * file,int * message)
{
 os_error    * err;
 fillstr       newfill;
 fillstr       oldfill;
 int           message2;
 undofillstr   undofill;
 int           key;
 int           master;
 objectbitstr  bits;


 key=obj->key;

 err=objectmaster(key,file,&master,&bits);
 if(!err)
 {
  if(!master || bits.local)
  {
   message2=OM_GETFILL;
   objectmessage2(key,file,&message2,&oldfill);

   newfill.fill=0;

   message2=OM_SETFILL;
   objectmessage2(key,file,&message2,&newfill);

   undofill.object=key;
   undofill.newfill=newfill;
   undofill.oldfill=oldfill;

   undowritefn(file,USFILL,&undofill,sizeof(undofill));
  }
 }

 return(err);

 USE(message);
}





os_error * remfillselection(filestr * file)
{
 os_error          * err;
 int                 selectn;
 selectedobjectstr * selection;
 filestr           * selfile;
 int                 selpage;
 int                 selsect;
 int                 message;


 err=NULL;

 selfile=getselection(&selpage,&selsect,&selection,&selectn);
 if(selfile==file)
 {
  err=modfile(selfile,selsect);
  if(!err)
  {
   err=undostart(selfile);
   if(!err)
   {
    unfillselectionf(selfile);

    message=OM_FUNCTION;

    selectionmessage(file,&message,(void*)remfillobjectfn);

    unfillselections(selfile);

    undoend(selfile);
   }
  }
 }

 return(err);
}







static os_error * getfillobjectfn(objhdrstr * obj,filestr * file,int * message)
{
 os_error * err;
 int        message2;

 message2=OM_GETFILL;
 err=objectmessage(obj,file,&message2,&xfill);
 if(!message2)
 {
  cfillobject=obj->key;
  if(xfill.fill) *message=0;
 }

 return(err);
}




static os_error * getfillselection(filestr * file,fillstr * fill)
{
 os_error * err;
 int        message;

 err=NULL;

 fill->fill=0;
 message=OM_FUNCTION;
 selectionmessage(file,&message,(void*)getfillobjectfn);

 if(!message) *fill=xfill;

 return(err);
}





#define UNDOS 3

static undofnstr undos[UNDOS]=
{
 unfillselectionf,      NULL,        USFILLF,      "{USFILL}",
 unfillselections,      NULL,        USFILLS,      "{USFILL}",
 unfill,                unfillscrap, USFILL,       NULL,

};







os_error * fillselectinit(void)
{
 os_error * err;

 err=undoaddblock(undos,UNDOS);

 return(err);
}



/****************************************************************************/


extern dboxstr fillboxdata[2];



static viewstr * cview;
static filestr * cfile;


static int       filltype;
static fillstr   cfill;
static int       cprocess;


static os_error * wrfilltype(int value,char * string)
{
 fillblockstr * rootp;

 rootp=findfillblock(filltype);

 if(rootp)
 {
  tsprintf(64,string,rootp->name);
 }

 return(NULL);
 USE(value);
}





/* int  fillname(int n,string & name);                      */
/* Return name/handle of nth. fill, return zero for no more */



int fillname(int fp)
{
 int            n;
 int            s;
 fillblockstr * rootp;
 int            state;
 int          * stack;
 char           temp[256];

 stack=xstackptr();

 n=stack[fp];
 s=stack[fp+1];

 rootp=getfillroot();
 state=0;

 do
 {
  rootp=(fillblockstr*)avlwalk((int)rootp,NULL,&state);
  if(rootp==((fillblockstr*)NIL_NODE)) break;
 } while(n--);


 if(n>=0) return(0);
 else
 {
  strcpy(temp,rootp->name);
  trans(temp,sizeof(temp));
  assignstring(s,temp);
  return(rootp->filltype);
 }
}




/* void setfill(int n) */

void setfill(int fp)
{
 int            n;
 int          * stack;
 fillblockstr * rootp;
 fillblockstr * oldp;
 int            state;

 stack=xstackptr();

 n=stack[fp];

 stack=xstackptr();


 oldp=findfillblock(filltype);

 rootp=getfillroot();
 state=0;
 do
 {
  rootp=(fillblockstr*)avlwalk((int)rootp,NULL,&state);
  if(rootp==((fillblockstr*)NIL_NODE)) break;
 } while(n--);



 if(n<0)
 {
  if(oldp->fpfn)  oldp->fpfn(0,&cfill,cview,fillboxdata);

  filltype=rootp->filltype;
  if(rootp->fpfn) rootp->fpfn(1,&cfill,cview,fillboxdata);

  dbchangepane(&fillboxdata[1],rootp->dbox,fillboxdata);
  (rootp->dbox)->handle=fillboxdata[1].handle;

  dbchangevalue(&filltype,fillboxdata);
 }
}





static os_error * fillclose(int code)
{
 os_error    * err;
 filldatastr   data;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  err=dbreadvalues(&fillboxdata[1]);

  memset(&data,0,sizeof(filldatastr));
  data.scale=data.aspect=0x10000;
  data.process=cprocess;

  err=fillselection(cfile,&cfill,&data,filltype);
 }

 if(!err && code!=DBAPPLY) deleteprocess(cprocess,cfile);

 return(err);
}



static os_error * screeninit(void)
{
 fillobjectstr * fb;

 cprocess=0;

 if(cfill.fill)
 {
  fb=(fillobjectstr*)fob_find(cfill.fill,cfile);
  copyprocess(fb->data.process,&cprocess,cfile);
 }

 return(NULL);
}



static os_error * closescreen(int process,int code)
{
 deleteprocess(cprocess,cfile);
 cprocess=process;

 USE(code);

 return(NULL);
}



static os_error * fillicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(m->i==3) err=openmenuparent("fillname_menu",handle);
 else
 if(m->i==9) err=openscreen(cprocess,cfile,fillboxdata,closescreen);

 return(err);

 USE(handle);
 USE(userhandle);
}





static os_error * deletefill(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=dbclose(fillboxdata,DBCANCEL);

 if(!err) err=remfillselection(cfile);

 return(err);

 USE(userhandle);
 USE(handle);
 USE(m);
}







static dbiconstr fillicondefs[]=
{
 /* N   &V           Type     Grp   Flags   Msk Key   ESG   -   clickfn 0 */

    6, &fillapply,   DBTOGGLE, 0,   0,     1,F1,0,0,       NULL, NULL,


   100, &filltype,    DBTEXT,   0,   0,     0,0,0,0,        NULL, wrfilltype,


    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,

    4, NULL,         DBACTION, 0,   0,      0, 0, 0, 0, (dbreadfn)deletefill,0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr fillboxdata[2]=
{
 0,
 TFILL,
 DBFIX,
 0,
 fillclose,
 fillicon,
 NULL,         /* fillkey */
 NULL,
 fillicondefs,
 0,
 0,
 0,NULL,
 0,
 0,


 0,
 TFILLBLOB,
 DBPANE,
 0,
 NULL,
 NULL,
 NULL,
 NULL,
 NULL,
 0,
 0,
 0,NULL,
 0,
 0,


};



/* script function opens the new document dialogue box */

os_error * filldbox(viewstr * view,filestr * file)
{
 os_error      * err;
 int             ob;
 fillblockstr  * rootp;
 fillobjectstr * fb;

 err=NULL;

 cview=view;
 cfile=file;

 if(nselected(&ob,cfile))
 {
  getfillselection(cfile,&cfill);

  if(!cfill.fill)
  {
   rootp=getfillroot();
   filltype=rootp->filltype;
  }
  else
  {
   fb=(fillobjectstr*)fob_find(cfill.fill,cfile);
   filltype=fb->filltype;
   rootp=findfillblock(filltype);
  }

  screeninit();

  fillboxdata[1]=*rootp->dbox;
  if(rootp->fpfn) rootp->fpfn(1,&cfill,cview,fillboxdata);

  err=dodboxspparent(fillboxdata,2,fillboxdata,getviewstack(),view->handle);
  if(!err)
  {
   (rootp->dbox)->handle=fillboxdata[1].handle;
  }
 }

 return(err);
}





int openfillbox(int fp)
{
 viewstr * view;
 filestr * file;

 view=getmenuview();
 file=view->file;

 zreport(filldbox(view,file));

 return(0);

 USE(fp);
}


