/*->c.fillblob */



#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"
#include "font.h"

#include "transform.h"

#include "xprocess.h"



#define DRAWFILE_INTERNAL
#include "DrawFile1.h"
#include "DrawLevel0.h"
#include "DrawLevel1.h"
#include "DrawFile2.h"
#include "DrawErrors.h"


#include "bits.h"
#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "sp.h"
#include "task.h"
#include "xhelp.h"
#include "trans.h"
#include "dbhi.h"
#include "key.h"
#include "temp.h"
#include "redraw.h"
#include "xmath.h"

#include "xext.h"



#include "constants.h"
#include "str.h"


#include "file.h"
#include "view.h"
#include "viewo.h"


#include "units.h"
#include "geometry.h"

#include "object.h"
#include "select.h"
#include "xredraw.h"
#include "xrender.h"
#include "curve.h"
#include "xxcolour.h"
#include "xcolour.h"
#include "colsep.h"
#include "dbcolour.h"
#include "mhi.h"
#include "dscript.h"
#include "line.h"



#include "filllink.h"

#include "filltool.h"
#include "dbfill.h"
#include "fill.h"


#include "fillblob.h"



#define MINRAD (MMRUNITS(1,2))



#define BLOBNAMESIZE 32



typedef struct blobstr
{
 char          name[BLOBNAMESIZE];

 colourvalue   line;
 colourvalue   fill;

 int           x;
 int           y;
 int           xscale;
 int           yscale;
 int           xrep;
 int           yrep;
 int           blobangle;
 int           blobskew;
 int           patternskew;
 int           shift;         /* derived from patternskew and yrep */
 int           style;
 int           stylescale;
 int           width;

 int           spare1;
 int           spare2;
 int           spare3;
 int           spare4;

} blobstr;




static blobstr defblob=
{
 "circle",
 OURBLACK,
 OURTRANS,
 0,
 0,
 0x8000,
 0x8000,
 MMSIZE*10,
 MMSIZE*10,
 0,
 0,
 0,
 0,
 0xFFFFFFFF,    /* solid */
 0x1400,
 MMRUNITS(1,4),  /* 0.25mm */

 0,
 0,
 0,
 0,
};



static int     cpatternangle;
static int     cx;
static int     cy;


static blobstr cblob;



/***************************************************************************/


typedef struct blobptrstr
{
 char    name[BLOBNAMESIZE];
 int     offset;
 int     size;
 aboxstr abox;

} blobptrstr;



#define BLOBPTRCHUNK  (16*sizeof(blobptrstr))
#define BLOBDATACHUNK (256*sizeof(int))


static int          nblobs;
static blobptrstr * blobptr;
static int          blobsize;
static int        * blobdata;






static os_error * parseblobs(char * filename)
{
 os_error          * err;
 char                name[BLOBNAMESIZE];
 buffer              bf;
 fstat               fs;
 int                 offset;
 Draw_objhdr         hdr;
 int                 offset1;
 int                 offset2;
 Draw_objhdr         hdr1;
 int                 seenpath;
 int                 seenname;
 int                 size;
 draw_pathstrhdr     dhdr;
 draw_dashstr        dash;


 err=fs_stat(filename,&fs);
 if(!err && fs.object==1)
 {
  err=bf_open(filename,'r',DEFBUFFSIZE,&bf);
  if(!err)
  {
   offset=sizeof(Draw_fileheader);

   while(offset<fs.length)
   {
    err=bf_seek(&bf,offset);
    if(err) break;

    err=bf_read(&bf,&hdr,sizeof(Draw_objhdr));
    if(err) break;

    if(hdr.tag==draw_OBJGROUP)
    {
     err=flex_chunk((flex_ptr)&blobptr,
                            (nblobs+1)*sizeof(blobptrstr),BLOBPTRCHUNK);

     if(err) break;

     seenpath=seenname=size=0;

     offset1=sizeof(draw_groustr);

     while(offset1<hdr.size)
     {
      err=bf_seek(&bf,offset+offset1);
      if(err) break;

      err=bf_read(&bf,&hdr1,sizeof(Draw_objhdr));
      if(err) break;

      if(hdr1.tag==draw_OBJPATH)
      {
       err=bf_seek(&bf,offset+offset1);
       if(err) break;

       err=bf_read(&bf,&dhdr,sizeof(draw_pathstrhdr));
       if(err) break;

       blobptr[nblobs].abox=*((aboxstr*)&dhdr.bbox);

       offset2=sizeof(draw_pathstrhdr);

       if(dhdr.pathstyle.joincapwind & packmask_dashed)
       {
        err=bf_read(&bf,&dash,2*sizeof(int));
        if(err) break;
        offset2+=2*sizeof(int);

        err=bf_read(&bf,dash.dashelements,dash.dashcount*sizeof(int));
        if(err) break;
        offset2+=dash.dashcount*sizeof(int);
       }

       size=hdr1.size-offset2;

       err=flex_chunk((flex_ptr)&blobdata,
                            (blobsize+size)*sizeof(int),BLOBDATACHUNK);
       if(err) break;

       err=bf_read(&bf,blobdata+blobsize,size);
       if(err) break;

       seenpath=1;
      }
      else
      if(hdr1.tag==draw_OBJTEXT)
      {
       err=bf_seek(&bf,offset+offset1+sizeof(draw_textstrhdr));
       if(err) break;
       err=bf_read(&bf,name,hdr1.size-sizeof(draw_textstrhdr));

       xstrncpy(blobptr[nblobs].name,name,BLOBNAMESIZE);
       seenname=1;
      }

      offset1+=hdr1.size;
     }

     if(err) break;

     if(seenpath && seenname)
     {
      size=size/sizeof(int);
      blobptr[nblobs].offset=blobsize;
      blobptr[nblobs].size=size;
      blobsize+=size;
      nblobs++;
     }
    }

    offset+=hdr.size;
   }

   err=bf_close(&bf,err);
  }
 }

 return(err);
}









static int blobcmp(const void * p1,const void * p2)
{
 return(cstrcmp(((blobstr*)p1)->name,((blobstr*)p2)->name));
}



os_error * blobrun(void)
{
 os_error * err;
 char       blobpath[FILENAMELEN];

 sprintf(blobpath,"%s\\Fill\\Blobs.drw",fillpath);

          err=flex_alloc((flex_ptr)&blobptr,BLOBPTRCHUNK);
 if(!err) err=flex_alloc((flex_ptr)&blobdata,BLOBDATACHUNK);
 if(!err)
 {
  err=parseblobs(blobpath);

  if(!err) err=flex_extend((flex_ptr)&blobptr,nblobs*sizeof(blobptrstr));
  if(!err) err=flex_extend((flex_ptr)&blobdata,blobsize*sizeof(int));

  if(!err && nblobs)
  {
   qsort(blobptr,nblobs,sizeof(blobptrstr),blobcmp);
   strcpy(defblob.name,blobptr->name);
  }
 }

 return(err);
}




static blobptrstr * blobfind(char * name)
{
 blobptrstr   blob;
 blobptrstr * bptr;

 strcpy(blob.name,name);

 bptr=(blobptrstr*)bsearch(&blob,blobptr,nblobs,sizeof(blobptrstr),blobcmp);

 if(!bptr) bptr=blobptr;

 return(bptr);
}




int blobname(int fp)
{
 int          * stack;
 char           temp[256];
 int            n;
 int            s;

 stack=xstackptr();

 n=stack[fp];
 s=stack[fp+1];

 if(n>=nblobs) return(0);
 else
 {
  strcpy(temp,blobptr[n].name);
  trans(temp,sizeof(temp));
  assignstring(s,temp);
  return(1);
 }
}



/*****************************************************************************/









/* abox   - area in OS units to render                 */
/* restr  - transform from fill space to Draw/OS space */
/* filltr - transform from fill space to page space    */
/* tr     - transform from curve space to page space   */


static os_error * blobrender(aboxstr * abox,transformstr * restr,
                              transformstr * filltr,
                              viewredrawstr * v,curvestr * c,
                              curvestylestr * cstyle,transformstr * tr)

{
 os_error      * err;
 fillobjectstr * fb;
 blobstr         blob;
 filestr       * file;
 viewstr       * view;
 aboxstr         dbox;
 aboxstr         maxbox;
 int             ylo;
 int             yhi;
 int             yi;
 int             xlo;
 int             xhi;
 transformstr    xtr;
 transformstr    ztr;
 int             x;
 int             y;
 int             transparent;
 blobptrstr   *  bptr;
 int             size;
 int             offset;
 pathstyle       pstyle;
 transformstr    tr1;
 transformstr    tr2;
 transformstr    tr3;
 transformstr    tr4;


 err=NULL;



 file=v->file;
 view=v->view;


 dbox=*abox;

 dbox.x0*=256;
 dbox.x1*=256;
 dbox.y0*=256;
 dbox.y1*=256;

 getmaxinvabox(&maxbox,&dbox,restr);



 fb=(fillobjectstr*)fob_find(cstyle->fill.fill,file);
 XMEMCPYX(&blob,((char*)fb)+sizeof(fillobjectstr),sizeof(blobstr));


 memset(&pstyle,0,sizeof(pathstyle));
 pstyle.style=blob.style;
 pstyle.stylescale=blob.stylescale;
 pstyle.thickness=blob.width;



 bptr=blobfind(blob.name);
 size=bptr->size*sizeof(int);
 offset=bptr->offset;

 tr_setshift(&tr1,-(bptr->abox.x0+bptr->abox.x1)/2,
                  -(bptr->abox.y0+bptr->abox.y1)/2);

 tr_setscale(&tr2,bptr->abox.x1-bptr->abox.x0,
                  scale(blob.xrep,blob.xscale,0x10000),
                  bptr->abox.y1-bptr->abox.y0,
                  -scale(blob.yrep,blob.yscale,0x10000));

 tr_multiply(&tr3,&tr1,&tr2);


 tr_setidentity(&tr1);
 tr_setskew(&tr1,blob.blobskew);

 tr_multiply(&tr2,&tr3,&tr1);

 tr_setidentity(&tr1);
 tr_setrotationa(&tr1,blob.blobangle);

 tr_multiply(&tr4,&tr2,&tr1);



 ylo=(maxbox.y0/blob.yrep);
 yi=ylo;
 ylo*=blob.yrep;
 if(ylo>maxbox.y0) 
 {
  ylo-=blob.yrep;
  yi--;
 }

 yhi=maxbox.y1;

 for(y=ylo;y<yhi;y+=blob.yrep,yi++)
 {
  xlo=(maxbox.x0-yi*blob.shift)/blob.xrep;
  xlo*=blob.xrep;
  xlo+=yi*blob.shift;
  if(xlo>maxbox.x0) xlo-=blob.xrep;

  xhi=maxbox.x1;

  for(x=xlo;x<xhi;x+=blob.xrep)
  {
   tr_setshift(&tr1,x+blob.xrep/2,y+blob.yrep/2);
   tr_multiply(&xtr,&tr4,&tr1);
   tr_multiply(&ztr,&xtr,restr);

//   vsetcolour(&blob.fill,&transparent,view);
   err=render_setcolour(&blob.fill,&transparent,v);
   if(!transparent)
   {
    pstyle.action=0x2;
    rpathlines(blobdata+offset,&pstyle,v,&ztr);
   }

//   vsetcolour(&blob.line,&transparent,view);
   err=render_setcolour(&blob.line,&transparent,v);
   if(!transparent)
   {
    pstyle.action=0x1;
    rpathlines(blobdata+offset,&pstyle,v,&ztr);
   }
  }
 }

 return(err);


 USE(tr);
 USE(filltr);
 USE(c);

}





static void blobshift(blobstr * blobp)
{
 double angle;

 angle=(((double)blobp->patternskew)/((double)0x10000));
 angle/=180.0;
 angle*=PI;

 blobp->shift=(int)((double)blobp->yrep*tan(angle));
}






static os_error * blobcreates(filestr * file,filldatastr * data,
                              blobstr * cblobp,fillstr * xnew,int xprocess)
{
 os_error      * err;
 fillobjectstr * fillp;
 blobstr       * blobp;
 int             process;

 err=NULL;

 if(xprocess) process=xprocess;
 else
 {
  err=copyprocess(data->process,&process,file);
 }

 if(!err)
 {
  err=fob_create(sizeof(fillobjectstr)+sizeof(blobstr),file,
                                                     OFILL,(fobjptr)&fillp);
  if(!err)
  {
   xnew->fill=fillp->key;
   fillp->data=*data;
   fillp->data.process=process;
   fillp->filltype=FL_BLOB;
   blobp=(blobstr*)(((char*)fillp)+sizeof(fillobjectstr));
   *blobp=*cblobp;

   blobshift(blobp);
  }
  else
  {
   deleteprocess(process,file);
  }
 }

 return(err);
}












static os_error * blobwrite(fillstr * fill,buffer * bf,filestr * file)
{
 os_error      * err;
 fillobjectstr * fb;
 blobstr       * blob;


 err=NULL;

 fb=(fillobjectstr*)fob_find(fill->fill,file);
 if(fb)
 {
  blob=(blobstr*)(((char*)fb)+sizeof(fillobjectstr));

           err=bf_printf(bf,"{fill {blob \"%s\" ",blob->name);

  if(!err) err=bf_printfeol(bf,"{thickness %d}",blob->width);
  if(!err) err=bf_printfeol(bf,"{linecolour %s}",dscvstring2(&blob->line,file));

  if(!err) err=bf_printfeol(bf,"{fillcolour %s}",dscvstring2(&blob->fill,file));

  if(!err) err=bf_printfeol(bf,"{linestyle 0x%x %d}",
                                           blob->style,blob->stylescale);

  if(!err) err=bf_printfeol(bf,"{x %d}",fb->data.x);
  if(!err) err=bf_printfeol(bf,"{y %d}",fb->data.y);

  if(!err) err=bf_printfeol(bf,"{x %d}",blob->xrep);
  if(!err) err=bf_printfeol(bf,"{y %d}",blob->yrep);

  if(!err) err=bf_printf(bf,"{scale 0x%x}",blob->xscale);
  if(!err) err=bf_printfeol(bf,"{scale 0x%x}",blob->yscale);

  if(!err) err=bf_printf(bf,"{angle 0x%x}",-blob->blobangle);
  if(!err) err=bf_printfeol(bf,"{skew 0x%x}",-blob->blobskew);

  if(!err) err=bf_printf(bf,"{angle 0x%x}",-fb->data.angle);
  if(!err) err=bf_printfeol(bf,"{skew 0x%x}",-blob->patternskew);

  if(!err) err=dswriteprocess(fb->data.process,bf,file);

  if(!err) err=bf_printf(bf,"}\r\n}\r\n");
 }

 return(err);
}






os_error * dsblob(int fp,int argc,objectloc * loc)
{
 os_error          * err;
 int                 sp;
 int                 nsp;
 dsobjectstr       * ds;
 dsobjectstr       * ds1;
 int                 xp;
 int               * dsstack;
 fillstr             fill;
 blobstr             blob;
 filldatastr         filldata;
 int                 seenposnx;
 int                 seenposny;
 int                 seenblobangle;
 int                 seenblobskew;
 int                 seenxscale;
 int                 seenyscale;
 int                 process;


 err=NULL;

 memset(&blob,0,sizeof(blobstr));
 memset(&filldata,0,sizeof(filldatastr));
 filldata.scale=filldata.aspect=0x10000;

 sp=fp+2; /* skip leading type/len */
 xp=sp;

 dsstack=dsstackptr();

 seenposnx=seenposny=seenblobangle=seenblobskew=seenxscale=seenyscale=0;
 process=0;

 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {
   case       DSTSTR:
                     strcpy(blob.name,ds->data.string);
                     break;


   case DSTTHICKNESS:
                     blob.width=ds1->data.integer;
                     break;

  case DSTLINECOLOUR:
                     blob.line.data.tint.key=ds1->data.integer;
                     ds1=(dsobjectstr*)(dsstack+sp+2+3);
                     blob.line.data.tint.tint=ds1->data.integer;
                     if(nsp>(sp+2+6))
                     {
                      ds1=(dsobjectstr*)(dsstack+sp+2+6);
                      blob.line.data.tint.overprint=ds1->data.integer;
                     }
                     break;

  case DSTFILLCOLOUR:
                     blob.fill.data.tint.key=ds1->data.integer;
                     ds1=(dsobjectstr*)(dsstack+sp+2+3);
                     blob.fill.data.tint.tint=ds1->data.integer;
                     if(nsp>(sp+2+6))
                     {
                      ds1=(dsobjectstr*)(dsstack+sp+2+6);
                      blob.fill.data.tint.overprint=ds1->data.integer;
                     }
                     break;


   case DSTLINESTYLE:
                     blob.style=ds1->data.integer;
                     ds1=(dsobjectstr*)(dsstack+sp+2+3);
                     blob.stylescale=ds1->data.integer;
                     break;

   case         DSTX:
                     if(seenposnx)
                     {
                      blob.xrep=ds1->data.integer;
                     }
                     else
                     {
                      filldata.x=ds1->data.integer;
                      seenposnx=1;
                     }
                     break;

   case         DSTY:
                     if(seenposny)
                     {
                      blob.yrep=ds1->data.integer;
                     }
                     else
                     {
                      filldata.y=ds1->data.integer;
                      seenposny=1;
                     }
                     break;

   case     DSTSCALE:
                     if(seenxscale)
                     {
                      blob.yscale=ds1->data.integer;
                     }
                     else
                     {
                      blob.xscale=ds1->data.integer;
                      seenxscale=1;
                     }
                     break;

   case     DSTANGLE:
                     if(seenblobangle)
                     {
                      filldata.angle=-ds1->data.integer;
                     }
                     else
                     {
                      blob.blobangle=-ds1->data.integer;
                      seenblobangle=1;
                     }
                     break;

   case      DSTSKEW:
                     if(seenblobskew)
                     {
                      blob.patternskew=-ds1->data.integer;
                     }
                     else
                     {
                      blob.blobskew=-ds1->data.integer;
                      seenblobskew=1;
                     }
                     break;

   case   DSTPROCESS:
                     process=ds->data.integer;
                     break;

  }
  sp=nsp;
 }


 err=blobcreates(loc->file,&filldata,&blob,&fill,process);
 if(!err)
 {
  dsstack=dsstackptr();

  ds=(dsobjectstr*)(dsstack+fp);
  ds->len=3*sizeof(int);
  ds->data.integer=fill.fill;
 }

 return(err);
}




static os_error * blobcopy(fillstr * d,filestr * dfile,
                         fillstr * s,filestr * sfile,int mode)
{
 os_error      * err;
 fillobjectstr * fillp;
 blobstr         blob;
 int             sprocess;
 int             dprocess;


 fillp=(fillobjectstr*)fob_find(s->fill,sfile);
 sprocess=fillp->data.process;

 err=copyprocessm(&dprocess,dfile,sprocess,sfile,mode);
 if(!err)
 {
  err=fob_copy((fobjptr)&fillp,dfile,s->fill,sfile);
  if(!err)
  {
   d->fill=fillp->key;
   fillp->data.process=dprocess;

   if(sfile!=dfile)
   {
    XMEMCPYX(&blob,(((char*)fillp)+sizeof(fillobjectstr)),sizeof(blobstr));
    mapcolour(sfile,dfile,&blob.line,mode);
    mapcolour(sfile,dfile,&blob.fill,mode);
    fob_mod(d->fill,dfile,(fobjptr)&fillp);
    XMEMCPYX((((char*)fillp)+sizeof(fillobjectstr)),&blob,sizeof(blobstr));
   }
  }
  else
  {
   deleteprocess(dprocess,dfile);
   d->fill=0;
  }
 }
 else
 {
  d->fill=0;
 }
 return(err);
}








static os_error * blobcreate(filestr * file,filldatastr * data,
                                            fillstr * xnew,fillstr * old)
{
 os_error * err;

 data->angle=cpatternangle;
 data->x=cx;
 data->y=cy;

 err=blobcreates(file,data,&cblob,xnew,0);

 return(err);

 USE(old);
}







static os_error * blobapply(filestr * file,filltoolstr * tool,
                                                 fillstr * xnew,fillstr * old)
{
 os_error      * err;
 fillobjectstr * fob;
 blobstr       * blobp;
 int             process;


 err=copyprocess(tool->process,&process,file);
 if(!err)
 {
  if(old && old->fill) err=fob_copy((fobjptr)&fob,file,old->fill,file);
  else                 err=fob_create(sizeof(fillobjectstr)+sizeof(blobstr),
                                                     file,OFILL,(fobjptr)&fob);
  if(!err)
  {
   xnew->fill=fob->key;
   fob->filltype=FL_BLOB;
   blobp=(blobstr*)(((char*)fob)+sizeof(fillobjectstr));
   if(!old || !old->fill) XMEMCPYX(blobp,&cblob,sizeof(blobstr));

   fob->data.x=tool->x;
   fob->data.y=tool->y;
   blobp->xrep=ttmul(tool->rx,tool->scale);
   blobp->xrep=FLOOR(blobp->xrep,MINRAD);
   blobp->yrep=ttmul(tool->ry,ttmul(tool->scale,tool->aspect));
   blobp->yrep=FLOOR(blobp->yrep,MINRAD);
   fob->data.angle=tool->angle;    /* pattern angle */
   blobp->patternskew=CUT(tool->skew,MINSKEW,MAXSKEW);
   blobshift(blobp);
   blobp->line=tool->c1;
   blobp->fill=tool->c2;
   fob->data.scale=0x10000;
   fob->data.aspect=0x10000;
   fob->data.process=process;
  }
  else
  {
   deleteprocess(process,file);
  }
 }
 return(err);

 USE(old);
}



static os_error * blobtool(filestr * file,filltoolstr * tool,fillstr * old)
{
 fillobjectstr * fob;
 blobstr       * blobp;


 if(old)
 {
  fob=(fillobjectstr*)fob_find(old->fill,file);
  blobp=(blobstr*)(((char*)fob)+sizeof(fillobjectstr));

  tool->process=fob->data.process;
  tool->x=fob->data.x;
  tool->y=fob->data.y;
  tool->rx=blobp->xrep;
  tool->ry=blobp->yrep;
  tool->angle=fob->data.angle;
  tool->skew=blobp->patternskew;
  tool->c1=blobp->line;
  tool->c2=blobp->fill;
  tool->filltype=fob->filltype;
  tool->scale=0x10000;
  tool->aspect=0x10000;
 }
 else
 {
  tool->process=0;
  tool->x=cx;
  tool->y=cy;
  tool->rx=cblob.xrep;
  tool->ry=cblob.yrep;
  tool->angle=cpatternangle;
  tool->skew=cblob.patternskew;
  tool->c1=cblob.line;
  tool->c2=cblob.fill;
  tool->filltype=FL_BLOB;
  tool->scale=0x10000;
  tool->aspect=0x10000;
 }

 return(NULL);
}





/*****************************************************************************/

extern dboxstr blobbox;

static viewstr * cview;
static filestr * cfile;

static dboxstr * cparent;



static os_error * outu(int value,char * string)
{
 strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}


static os_error * inu(int * value,char * string)
{
 return(stringtounits(string,value,cview->data.units));
}





static os_error * outr(int value,char * string)
{
 strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}


static os_error * inr(int * value,char * string)
{
 os_error * err;

 err=stringtounits(string,value,cview->data.units);
 if(!err)
 {
  *value=FLOOR((*value),MINRAD);
 }

 return(err);
}




static os_error * wrwidth(int value,char * string)
{
 if(value) return(outu(value,string));
 else
 {
  tsprintf(32,string,"{THIN}");
  return(NULL);
 }
}




static os_error * rdwidth(int * value,char * string)
{
 os_error * err;
 char       temp[64];

 err=NULL;

 tsprintf(sizeof(temp),temp,"{THIN}");
 if(!cstrcmp(temp,string)) *value=0;
 else                      err=inu(value,string);

 return(err);
}



static os_error * wrname(int value,char * string)
{
 strcpy(string,cblob.name);
 return(NULL);
 USE(value);
}




void setblob(int fp)
{
 int * stack;
 int   n;

 stack=xstackptr();

 n=stack[fp];

 if(n>=0 && n<nblobs)
 {
  strcpy(cblob.name,blobptr[n].name);
  dbchangevalue((int*)cblob.name,cparent);
 }
}



int currentblob(int fp)
{
 int * stack;
 int   n;

 stack=xstackptr();

 n=stack[fp];

 if(n>=0 && n<nblobs)
 {
  return(cstrcmp(cblob.name,blobptr[n].name));
 }

 return(1);
}






static os_error * blobredrawsub(int handle,wimp_redrawstr *redrawstr,int more)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  redrawblock(redrawstr,handle,7,vfindcolour2(NULL,cfile,&cblob.fill));
  redrawblock(redrawstr,handle,9,vfindcolour2(NULL,cfile,&cblob.line));

  wimp_get_rectangle(redrawstr,&more);
 }

 return(err);
}



static os_error * blobredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) blobredrawsub(handle,&redrawstr,more);
 return(err);

 USE(userhandle);
}






void setblobwidth(int fp)
{
 int * stack;
 stack=xstackptr();
 cblob.width=stack[fp];
 dbchangevalue(&cblob.width,cparent);
}


int getblobwidth(int fp)
{
 return(cblob.width);
 USE(fp);
}


void setblobpattern(int fp)
{
 int * stack;
 stack=xstackptr();
 cblob.style=stack[fp];
 cblob.stylescale=stack[fp+1];
 dbchangevalue(&cblob.style,cparent);
}


int getblobpattern(int fp)
{
 return(cblob.style);
 USE(fp);
}


int getblobscale(int fp)
{
 return(cblob.stylescale);
 USE(fp);
}





static void fillpickclose(colourvalue * colour)
{
 cblob.fill=*colour;
 wimp_set_icon_state(blobbox.handle,7,(wimp_iconflags)0,(wimp_iconflags)0);
}


static void linepickclose(colourvalue * colour)
{
 cblob.line=*colour;
 wimp_set_icon_state(blobbox.handle,9,(wimp_iconflags)0,(wimp_iconflags)0);
}




static os_error * blobicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case  4:
          err=openmenuparent("blobname_menu",handle);
          break;

  case 12:
          err=pickcolour(cfile,&cblob.fill,fillpickclose,(dboxstr*)userhandle);
          break;

  case 10:
          err=pickcolour(cfile,&cblob.line,linepickclose,(dboxstr*)userhandle);
          break;

  case 21:
          err=openmenuparent("blobstyle_menu",handle);
          break;

  case 18:
          err=openmenuparent("blobwidth_menu",handle);
          break;

 }

 return(err);

 USE(handle);
}





#define BLOBMINSCALE (0x10000/100)
#define BLOBMAXSCALE (0x10000*10)


static os_error * writeblobpc(int value,char * string)
{
 strcpy(string,numbertostringxdp(value,2,2));
 return(NULL);
}



static os_error * readblobpc(int * value,char * string)
{
 os_error * err;
 int        scale;

 err=stringtonumberxdp(string,&scale,2,2);

 *value=CUT(scale,BLOBMINSCALE,BLOBMAXSCALE);

 return(err);
}







static dbiconstr blobicondefs[]=
{
 /* N   &V           Type     Grp   Flags   Msk Key   ESG   -   clickfn 0 */

    2, &cx,              DBWRITE,  0,   0,    -1, -1, 3,-1,    inu, outu,
    3, &cy,              DBWRITE,  0,   0,    -1, -1, 3,-1,    inu, outu,

   13, &cblob.xscale,    DBWRITE,  0,   0,    -1, -1, 3,-1,readblobpc,
                                                           writeblobpc,

   23, &cblob.yscale,    DBWRITE,  0,   0,    -1, -1, 3,-1,readblobpc,
                                                           writeblobpc,

   24, &cblob.xrep,      DBWRITE,  0,   0,    -1, -1, 3,-1,    inr, outr,
   25, &cblob.yrep,      DBWRITE,  0,   0,    -1, -1, 3,-1,    inr, outr,

   28, &cblob.blobangle, DBWRITE,  0,   0,   -1, -1, 3,-1,readangle,writeangle,

   29, &cblob.blobskew,  DBWRITE,  0,   0,   -1, -1, 3,-1,readskew,writeskew,

   32, &cpatternangle,   DBWRITE,  0,   0,   -1, -1, 3,-1,readangle,writeangle,

   33, &cblob.patternskew,DBWRITE, 0,   0,   -1, -1, 3,-1,readskew,writeskew,


   20, &cblob.style,     DBTEXT,   0,   0,     0,0,0,0,        NULL,NULL,

   17, &cblob.width,     DBWRITE,  0,   0,     0,0,0,0,        rdwidth,wrwidth,

    5,(int*)cblob.name,  DBTEXT,   0,   0,     0,0,0,0,        NULL,wrname,


 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};








static dboxstr blobbox=
{
 0,
 TFILLBLOB,
 DBPANE,
 0,
 NULL,
 blobicon,
 NULL,
 blobredraw,
 blobicondefs,
 0,
 0,
 0,NULL,
 0,
 0,

};








static os_error * blobpane(int open,fillstr * fill,
                                             viewstr * view,dboxstr * parent)
{
 fillobjectstr * fb;

 if(open)
 {
  cview=view;
  cfile=cview->file;
  cparent=parent;

  if(!fill->fill)
  {
   XMEMCPYX(&cblob,&defblob,sizeof(blobstr));
   cx=cy=0;
  }
  else
  {
   fb=(fillobjectstr*)fob_find(fill->fill,cfile);
   if(fb->filltype==FL_BLOB)
   {
    XMEMCPYX(&cblob,((char*)fb)+sizeof(fillobjectstr),sizeof(blobstr));
    cpatternangle=fb->data.angle;
    cx=fb->data.x;
    cy=fb->data.y;
   }
   else
   {
    XMEMCPYX(&cblob,&defblob,sizeof(blobstr));
    cpatternangle=0;
    cx=cy=0;
   }
  }
 }

 return(NULL);
}







static fillblockstr blobblock=
{
 0,0,0,0,


 FL_BLOB,

 NULL,
 blobcopy,
 NULL,
 blobwrite,

 "{FIL01}",
 &blobbox,


 blobpane,
 blobrender,
 blobcreate,
 0,
 blobapply,
 blobtool,

 NULL,          /* no direct render */

};





os_error * fillblobinit(void)
{
 return(filllinkblock(&blobblock));
}







#ifdef NEVER





#define DSTBLOBSTYLE 0x1480



static os_error * dsblob(int fp,int argc,objectloc * loc)
{
 os_error          * err;
 int                 sp;
 int                 nsp;
 dsobjectstr       * ds;
 dsobjectstr       * ds1;
 char                name[BLOBNAMESIZE];
 int                 xp;
 int               * dsstack;
 int                 size;


 err=NULL;


 sp=fp+2; /* skip leading type/len */
 xp=sp;

 dsstack=dsstackptr();

 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);


  switch(ds->type)
  {
   case       DSTSTR:
                     strcpy(name,ds->data.string);
                     break;


   case      DSTMOVE:
                     dsstack[xp++]=DRAWMOVE;
                     ds=(dsobjectstr*)(dsstack+sp+2);
                     dsstack[xp++]=ds->data.integer;
                     ds=(dsobjectstr*)(dsstack+sp+2+3);
                     dsstack[xp++]=ds->data.integer;
                     break;

   case      DSTDRAW:
                     dsstack[xp++]=DRAWDRAW;
                     ds=(dsobjectstr*)(dsstack+sp+2);
                     dsstack[xp++]=ds->data.integer;
                     ds=(dsobjectstr*)(dsstack+sp+2+3);
                     dsstack[xp++]=ds->data.integer;
                     break;

   case     DSTCURVE:
                     dsstack[xp++]=DRAWCURVE;
                     ds=(dsobjectstr*)(dsstack+sp+2);
                     dsstack[xp++]=ds->data.integer;
                     ds=(dsobjectstr*)(dsstack+sp+2+3);
                     dsstack[xp++]=ds->data.integer;
                     ds=(dsobjectstr*)(dsstack+sp+2+6);
                     dsstack[xp++]=ds->data.integer;
                     ds=(dsobjectstr*)(dsstack+sp+2+9);
                     dsstack[xp++]=ds->data.integer;
                     ds=(dsobjectstr*)(dsstack+sp+2+12);
                     dsstack[xp++]=ds->data.integer;
                     ds=(dsobjectstr*)(dsstack+sp+2+15);
                     dsstack[xp++]=ds->data.integer;
                     break;

   case     DSTCLOSE:
                     dsstack[xp++]=DRAWCLOSE;
                     break;

   case       DSTEND:
                     dsstack[xp++]=DRAWEND;
                     break;

  }
  sp=nsp;
 }



 if(!err)
 {
  size=(xp-(fp+2));

           err=flex_chunk((flex_ptr)&blobptr,
                            (nblobs+1)*sizeof(blobptrstr),BLOBPTRCHUNK);

  if(!err) err=flex_chunk((flex_ptr)&blobdata,
                            (blobsize+size)*sizeof(int),BLOBDATACHUNK);

  dsstack=dsstackptr();

  strcpy(blobptr[nblobs].name,name);
  blobptr[nblobs].offset=blobsize;
  blobptr[nblobs].size=size;
  XMEMCPYX(blobdata+blobsize,&dsstack[fp+2],size*sizeof(int));
  nblobs++;
  blobsize+=size;

  ds=(dsobjectstr*)(dsstack+fp);
  ds->len=2*sizeof(int);
 }


 return(err);

 USE(loc);
}





static int dsnulllist[]={
                           DSTENDLIST
                          };



static dscreator dsdefs[]=
{
 0,0,0,0, "blobstyle",  dsblob,   0, DSTBLOBSTYLE,  dsnulllist,
};





static int blobcmp(const void * p1,const void * p2)
{
 return(strcmp(((blobstr*)p1)->name,((blobstr*)p2)->name));
}






os_error * blobrun(void)
{
 os_error * err;
 char       blobpath[MAXFILENAMELEN];

 sprintf(blobpath,"%s\\Fill\\Blobs.drw",fillpath);

          err=flex_alloc((flex_ptr)&blobptr,BLOBPTRCHUNK);
 if(!err) err=flex_alloc((flex_ptr)&blobdata,BLOBDATACHUNK);
 if(!err)
 {
  err=dsaddblock(dsdefs,sizeof(dsdefs)/sizeof(dscreator));
  if(!err) err=dsexec(blobpath,0);

  if(err) dprintf(0,"%s",err->errmess);
  if(!err) err=flex_extend((flex_ptr)&blobptr,nblobs*sizeof(blobptrstr));
  if(!err) err=flex_extend((flex_ptr)&blobdata,blobsize*sizeof(int));

  if(!err)
  {
   qsort(blobptr,nblobs,sizeof(blobptrstr),blobcmp);
  }
 }

 return(err);
}







#endif


